// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: msp/msp_principal.proto

package org.hyperledger.fabric.protos.common;

public final class MspPrincipal {
  private MspPrincipal() {}
  public static void registerAllExtensions(
      com.google.protobuf.ExtensionRegistryLite registry) {
  }

  public static void registerAllExtensions(
      com.google.protobuf.ExtensionRegistry registry) {
    registerAllExtensions(
        (com.google.protobuf.ExtensionRegistryLite) registry);
  }
  public interface MSPPrincipalOrBuilder extends
      // @@protoc_insertion_point(interface_extends:common.MSPPrincipal)
      com.google.protobuf.MessageOrBuilder {

    /**
     * <pre>
     * Classification describes the way that one should process
     * Principal. An Classification value of "ByOrganizationUnit" reflects
     * that "Principal" contains the name of an organization this MSP
     * handles. A Classification value "ByIdentity" means that
     * "Principal" contains a specific identity. Default value
     * denotes that Principal contains one of the groups by
     * default supported by all MSPs ("admin" or "member").
     * </pre>
     *
     * <code>optional .common.MSPPrincipal.Classification principal_classification = 1;</code>
     */
    int getPrincipalClassificationValue();
    /**
     * <pre>
     * Classification describes the way that one should process
     * Principal. An Classification value of "ByOrganizationUnit" reflects
     * that "Principal" contains the name of an organization this MSP
     * handles. A Classification value "ByIdentity" means that
     * "Principal" contains a specific identity. Default value
     * denotes that Principal contains one of the groups by
     * default supported by all MSPs ("admin" or "member").
     * </pre>
     *
     * <code>optional .common.MSPPrincipal.Classification principal_classification = 1;</code>
     */
    org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal.Classification getPrincipalClassification();

    /**
     * <pre>
     * Principal completes the policy principal definition. For the default
     * principal types, Principal can be either "Admin" or "Member".
     * For the ByOrganizationUnit/ByIdentity values of Classification,
     * PolicyPrincipal acquires its value from an organization unit or
     * identity, respectively.
     * For the Combined Classification type, the Principal is a marshalled
     * CombinedPrincipal.
     * </pre>
     *
     * <code>optional bytes principal = 2;</code>
     */
    com.google.protobuf.ByteString getPrincipal();
  }
  /**
   * <pre>
   * MSPPrincipal aims to represent an MSP-centric set of identities.
   * In particular, this structure allows for definition of
   *  - a group of identities that are member of the same MSP
   *  - a group of identities that are member of the same organization unit
   *    in the same MSP
   *  - a group of identities that are administering a specific MSP
   *  - a specific identity
   * Expressing these groups is done given two fields of the fields below
   *  - Classification, that defines the type of classification of identities
   *    in an MSP this principal would be defined on; Classification can take
   *    three values:
   *     (i)  ByMSPRole: that represents a classification of identities within
   *          MSP based on one of the two pre-defined MSP rules, "member" and "admin"
   *     (ii) ByOrganizationUnit: that represents a classification of identities
   *          within MSP based on the organization unit an identity belongs to
   *     (iii)ByIdentity that denotes that MSPPrincipal is mapped to a single
   *          identity/certificate; this would mean that the Principal bytes
   *          message
   * </pre>
   *
   * Protobuf type {@code common.MSPPrincipal}
   */
  public  static final class MSPPrincipal extends
      com.google.protobuf.GeneratedMessageV3 implements
      // @@protoc_insertion_point(message_implements:common.MSPPrincipal)
      MSPPrincipalOrBuilder {
    // Use MSPPrincipal.newBuilder() to construct.
    private MSPPrincipal(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
      super(builder);
    }
    private MSPPrincipal() {
      principalClassification_ = 0;
      principal_ = com.google.protobuf.ByteString.EMPTY;
    }

    @java.lang.Override
    public final com.google.protobuf.UnknownFieldSet
    getUnknownFields() {
      return com.google.protobuf.UnknownFieldSet.getDefaultInstance();
    }
    private MSPPrincipal(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      this();
      int mutable_bitField0_ = 0;
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            default: {
              if (!input.skipField(tag)) {
                done = true;
              }
              break;
            }
            case 8: {
              int rawValue = input.readEnum();

              principalClassification_ = rawValue;
              break;
            }
            case 18: {

              principal_ = input.readBytes();
              break;
            }
          }
        }
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(this);
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(
            e).setUnfinishedMessage(this);
      } finally {
        makeExtensionsImmutable();
      }
    }
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return org.hyperledger.fabric.protos.common.MspPrincipal.internal_static_common_MSPPrincipal_descriptor;
    }

    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return org.hyperledger.fabric.protos.common.MspPrincipal.internal_static_common_MSPPrincipal_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal.class, org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal.Builder.class);
    }

    /**
     * Protobuf enum {@code common.MSPPrincipal.Classification}
     */
    public enum Classification
        implements com.google.protobuf.ProtocolMessageEnum {
      /**
       * <pre>
       * Represents the one of the dedicated MSP roles, the
       * </pre>
       *
       * <code>ROLE = 0;</code>
       */
      ROLE(0),
      /**
       * <pre>
       * one of a member of MSP network, and the one of an
       * administrator of an MSP network
       * </pre>
       *
       * <code>ORGANIZATION_UNIT = 1;</code>
       */
      ORGANIZATION_UNIT(1),
      /**
       * <pre>
       * groupping of entities, per MSP affiliation
       * E.g., this can well be represented by an MSP's
       * Organization unit
       * </pre>
       *
       * <code>IDENTITY = 2;</code>
       */
      IDENTITY(2),
      /**
       * <pre>
       * identity
       * </pre>
       *
       * <code>ANONYMITY = 3;</code>
       */
      ANONYMITY(3),
      /**
       * <pre>
       * an identity to be anonymous or nominal.
       * </pre>
       *
       * <code>COMBINED = 4;</code>
       */
      COMBINED(4),
      UNRECOGNIZED(-1),
      ;

      /**
       * <pre>
       * Represents the one of the dedicated MSP roles, the
       * </pre>
       *
       * <code>ROLE = 0;</code>
       */
      public static final int ROLE_VALUE = 0;
      /**
       * <pre>
       * one of a member of MSP network, and the one of an
       * administrator of an MSP network
       * </pre>
       *
       * <code>ORGANIZATION_UNIT = 1;</code>
       */
      public static final int ORGANIZATION_UNIT_VALUE = 1;
      /**
       * <pre>
       * groupping of entities, per MSP affiliation
       * E.g., this can well be represented by an MSP's
       * Organization unit
       * </pre>
       *
       * <code>IDENTITY = 2;</code>
       */
      public static final int IDENTITY_VALUE = 2;
      /**
       * <pre>
       * identity
       * </pre>
       *
       * <code>ANONYMITY = 3;</code>
       */
      public static final int ANONYMITY_VALUE = 3;
      /**
       * <pre>
       * an identity to be anonymous or nominal.
       * </pre>
       *
       * <code>COMBINED = 4;</code>
       */
      public static final int COMBINED_VALUE = 4;


      public final int getNumber() {
        if (this == UNRECOGNIZED) {
          throw new java.lang.IllegalArgumentException(
              "Can't get the number of an unknown enum value.");
        }
        return value;
      }

      /**
       * @deprecated Use {@link #forNumber(int)} instead.
       */
      @java.lang.Deprecated
      public static Classification valueOf(int value) {
        return forNumber(value);
      }

      public static Classification forNumber(int value) {
        switch (value) {
          case 0: return ROLE;
          case 1: return ORGANIZATION_UNIT;
          case 2: return IDENTITY;
          case 3: return ANONYMITY;
          case 4: return COMBINED;
          default: return null;
        }
      }

      public static com.google.protobuf.Internal.EnumLiteMap<Classification>
          internalGetValueMap() {
        return internalValueMap;
      }
      private static final com.google.protobuf.Internal.EnumLiteMap<
          Classification> internalValueMap =
            new com.google.protobuf.Internal.EnumLiteMap<Classification>() {
              public Classification findValueByNumber(int number) {
                return Classification.forNumber(number);
              }
            };

      public final com.google.protobuf.Descriptors.EnumValueDescriptor
          getValueDescriptor() {
        return getDescriptor().getValues().get(ordinal());
      }
      public final com.google.protobuf.Descriptors.EnumDescriptor
          getDescriptorForType() {
        return getDescriptor();
      }
      public static final com.google.protobuf.Descriptors.EnumDescriptor
          getDescriptor() {
        return org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal.getDescriptor().getEnumTypes().get(0);
      }

      private static final Classification[] VALUES = values();

      public static Classification valueOf(
          com.google.protobuf.Descriptors.EnumValueDescriptor desc) {
        if (desc.getType() != getDescriptor()) {
          throw new java.lang.IllegalArgumentException(
            "EnumValueDescriptor is not for this type.");
        }
        if (desc.getIndex() == -1) {
          return UNRECOGNIZED;
        }
        return VALUES[desc.getIndex()];
      }

      private final int value;

      private Classification(int value) {
        this.value = value;
      }

      // @@protoc_insertion_point(enum_scope:common.MSPPrincipal.Classification)
    }

    public static final int PRINCIPAL_CLASSIFICATION_FIELD_NUMBER = 1;
    private int principalClassification_;
    /**
     * <pre>
     * Classification describes the way that one should process
     * Principal. An Classification value of "ByOrganizationUnit" reflects
     * that "Principal" contains the name of an organization this MSP
     * handles. A Classification value "ByIdentity" means that
     * "Principal" contains a specific identity. Default value
     * denotes that Principal contains one of the groups by
     * default supported by all MSPs ("admin" or "member").
     * </pre>
     *
     * <code>optional .common.MSPPrincipal.Classification principal_classification = 1;</code>
     */
    public int getPrincipalClassificationValue() {
      return principalClassification_;
    }
    /**
     * <pre>
     * Classification describes the way that one should process
     * Principal. An Classification value of "ByOrganizationUnit" reflects
     * that "Principal" contains the name of an organization this MSP
     * handles. A Classification value "ByIdentity" means that
     * "Principal" contains a specific identity. Default value
     * denotes that Principal contains one of the groups by
     * default supported by all MSPs ("admin" or "member").
     * </pre>
     *
     * <code>optional .common.MSPPrincipal.Classification principal_classification = 1;</code>
     */
    public org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal.Classification getPrincipalClassification() {
      org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal.Classification result = org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal.Classification.valueOf(principalClassification_);
      return result == null ? org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal.Classification.UNRECOGNIZED : result;
    }

    public static final int PRINCIPAL_FIELD_NUMBER = 2;
    private com.google.protobuf.ByteString principal_;
    /**
     * <pre>
     * Principal completes the policy principal definition. For the default
     * principal types, Principal can be either "Admin" or "Member".
     * For the ByOrganizationUnit/ByIdentity values of Classification,
     * PolicyPrincipal acquires its value from an organization unit or
     * identity, respectively.
     * For the Combined Classification type, the Principal is a marshalled
     * CombinedPrincipal.
     * </pre>
     *
     * <code>optional bytes principal = 2;</code>
     */
    public com.google.protobuf.ByteString getPrincipal() {
      return principal_;
    }

    private byte memoizedIsInitialized = -1;
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized == 1) return true;
      if (isInitialized == 0) return false;

      memoizedIsInitialized = 1;
      return true;
    }

    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      if (principalClassification_ != org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal.Classification.ROLE.getNumber()) {
        output.writeEnum(1, principalClassification_);
      }
      if (!principal_.isEmpty()) {
        output.writeBytes(2, principal_);
      }
    }

    public int getSerializedSize() {
      int size = memoizedSize;
      if (size != -1) return size;

      size = 0;
      if (principalClassification_ != org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal.Classification.ROLE.getNumber()) {
        size += com.google.protobuf.CodedOutputStream
          .computeEnumSize(1, principalClassification_);
      }
      if (!principal_.isEmpty()) {
        size += com.google.protobuf.CodedOutputStream
          .computeBytesSize(2, principal_);
      }
      memoizedSize = size;
      return size;
    }

    private static final long serialVersionUID = 0L;
    @java.lang.Override
    public boolean equals(final java.lang.Object obj) {
      if (obj == this) {
       return true;
      }
      if (!(obj instanceof org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal)) {
        return super.equals(obj);
      }
      org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal other = (org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal) obj;

      boolean result = true;
      result = result && principalClassification_ == other.principalClassification_;
      result = result && getPrincipal()
          .equals(other.getPrincipal());
      return result;
    }

    @java.lang.Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptorForType().hashCode();
      hash = (37 * hash) + PRINCIPAL_CLASSIFICATION_FIELD_NUMBER;
      hash = (53 * hash) + principalClassification_;
      hash = (37 * hash) + PRINCIPAL_FIELD_NUMBER;
      hash = (53 * hash) + getPrincipal().hashCode();
      hash = (29 * hash) + unknownFields.hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }
    public static org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input);
    }
    public static org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
    }
    public static org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }

    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder() {
      return DEFAULT_INSTANCE.toBuilder();
    }
    public static Builder newBuilder(org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal prototype) {
      return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }
    public Builder toBuilder() {
      return this == DEFAULT_INSTANCE
          ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * <pre>
     * MSPPrincipal aims to represent an MSP-centric set of identities.
     * In particular, this structure allows for definition of
     *  - a group of identities that are member of the same MSP
     *  - a group of identities that are member of the same organization unit
     *    in the same MSP
     *  - a group of identities that are administering a specific MSP
     *  - a specific identity
     * Expressing these groups is done given two fields of the fields below
     *  - Classification, that defines the type of classification of identities
     *    in an MSP this principal would be defined on; Classification can take
     *    three values:
     *     (i)  ByMSPRole: that represents a classification of identities within
     *          MSP based on one of the two pre-defined MSP rules, "member" and "admin"
     *     (ii) ByOrganizationUnit: that represents a classification of identities
     *          within MSP based on the organization unit an identity belongs to
     *     (iii)ByIdentity that denotes that MSPPrincipal is mapped to a single
     *          identity/certificate; this would mean that the Principal bytes
     *          message
     * </pre>
     *
     * Protobuf type {@code common.MSPPrincipal}
     */
    public static final class Builder extends
        com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
        // @@protoc_insertion_point(builder_implements:common.MSPPrincipal)
        org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipalOrBuilder {
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return org.hyperledger.fabric.protos.common.MspPrincipal.internal_static_common_MSPPrincipal_descriptor;
      }

      protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return org.hyperledger.fabric.protos.common.MspPrincipal.internal_static_common_MSPPrincipal_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal.class, org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal.Builder.class);
      }

      // Construct using org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal.newBuilder()
      private Builder() {
        maybeForceBuilderInitialization();
      }

      private Builder(
          com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
        super(parent);
        maybeForceBuilderInitialization();
      }
      private void maybeForceBuilderInitialization() {
        if (com.google.protobuf.GeneratedMessageV3
                .alwaysUseFieldBuilders) {
        }
      }
      public Builder clear() {
        super.clear();
        principalClassification_ = 0;

        principal_ = com.google.protobuf.ByteString.EMPTY;

        return this;
      }

      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return org.hyperledger.fabric.protos.common.MspPrincipal.internal_static_common_MSPPrincipal_descriptor;
      }

      public org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal getDefaultInstanceForType() {
        return org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal.getDefaultInstance();
      }

      public org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal build() {
        org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      public org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal buildPartial() {
        org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal result = new org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal(this);
        result.principalClassification_ = principalClassification_;
        result.principal_ = principal_;
        onBuilt();
        return result;
      }

      public Builder clone() {
        return (Builder) super.clone();
      }
      public Builder setField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          Object value) {
        return (Builder) super.setField(field, value);
      }
      public Builder clearField(
          com.google.protobuf.Descriptors.FieldDescriptor field) {
        return (Builder) super.clearField(field);
      }
      public Builder clearOneof(
          com.google.protobuf.Descriptors.OneofDescriptor oneof) {
        return (Builder) super.clearOneof(oneof);
      }
      public Builder setRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          int index, Object value) {
        return (Builder) super.setRepeatedField(field, index, value);
      }
      public Builder addRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          Object value) {
        return (Builder) super.addRepeatedField(field, value);
      }
      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal) {
          return mergeFrom((org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal other) {
        if (other == org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal.getDefaultInstance()) return this;
        if (other.principalClassification_ != 0) {
          setPrincipalClassificationValue(other.getPrincipalClassificationValue());
        }
        if (other.getPrincipal() != com.google.protobuf.ByteString.EMPTY) {
          setPrincipal(other.getPrincipal());
        }
        onChanged();
        return this;
      }

      public final boolean isInitialized() {
        return true;
      }

      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal parsedMessage = null;
        try {
          parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          parsedMessage = (org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal) e.getUnfinishedMessage();
          throw e.unwrapIOException();
        } finally {
          if (parsedMessage != null) {
            mergeFrom(parsedMessage);
          }
        }
        return this;
      }

      private int principalClassification_ = 0;
      /**
       * <pre>
       * Classification describes the way that one should process
       * Principal. An Classification value of "ByOrganizationUnit" reflects
       * that "Principal" contains the name of an organization this MSP
       * handles. A Classification value "ByIdentity" means that
       * "Principal" contains a specific identity. Default value
       * denotes that Principal contains one of the groups by
       * default supported by all MSPs ("admin" or "member").
       * </pre>
       *
       * <code>optional .common.MSPPrincipal.Classification principal_classification = 1;</code>
       */
      public int getPrincipalClassificationValue() {
        return principalClassification_;
      }
      /**
       * <pre>
       * Classification describes the way that one should process
       * Principal. An Classification value of "ByOrganizationUnit" reflects
       * that "Principal" contains the name of an organization this MSP
       * handles. A Classification value "ByIdentity" means that
       * "Principal" contains a specific identity. Default value
       * denotes that Principal contains one of the groups by
       * default supported by all MSPs ("admin" or "member").
       * </pre>
       *
       * <code>optional .common.MSPPrincipal.Classification principal_classification = 1;</code>
       */
      public Builder setPrincipalClassificationValue(int value) {
        principalClassification_ = value;
        onChanged();
        return this;
      }
      /**
       * <pre>
       * Classification describes the way that one should process
       * Principal. An Classification value of "ByOrganizationUnit" reflects
       * that "Principal" contains the name of an organization this MSP
       * handles. A Classification value "ByIdentity" means that
       * "Principal" contains a specific identity. Default value
       * denotes that Principal contains one of the groups by
       * default supported by all MSPs ("admin" or "member").
       * </pre>
       *
       * <code>optional .common.MSPPrincipal.Classification principal_classification = 1;</code>
       */
      public org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal.Classification getPrincipalClassification() {
        org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal.Classification result = org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal.Classification.valueOf(principalClassification_);
        return result == null ? org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal.Classification.UNRECOGNIZED : result;
      }
      /**
       * <pre>
       * Classification describes the way that one should process
       * Principal. An Classification value of "ByOrganizationUnit" reflects
       * that "Principal" contains the name of an organization this MSP
       * handles. A Classification value "ByIdentity" means that
       * "Principal" contains a specific identity. Default value
       * denotes that Principal contains one of the groups by
       * default supported by all MSPs ("admin" or "member").
       * </pre>
       *
       * <code>optional .common.MSPPrincipal.Classification principal_classification = 1;</code>
       */
      public Builder setPrincipalClassification(org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal.Classification value) {
        if (value == null) {
          throw new NullPointerException();
        }
        
        principalClassification_ = value.getNumber();
        onChanged();
        return this;
      }
      /**
       * <pre>
       * Classification describes the way that one should process
       * Principal. An Classification value of "ByOrganizationUnit" reflects
       * that "Principal" contains the name of an organization this MSP
       * handles. A Classification value "ByIdentity" means that
       * "Principal" contains a specific identity. Default value
       * denotes that Principal contains one of the groups by
       * default supported by all MSPs ("admin" or "member").
       * </pre>
       *
       * <code>optional .common.MSPPrincipal.Classification principal_classification = 1;</code>
       */
      public Builder clearPrincipalClassification() {
        
        principalClassification_ = 0;
        onChanged();
        return this;
      }

      private com.google.protobuf.ByteString principal_ = com.google.protobuf.ByteString.EMPTY;
      /**
       * <pre>
       * Principal completes the policy principal definition. For the default
       * principal types, Principal can be either "Admin" or "Member".
       * For the ByOrganizationUnit/ByIdentity values of Classification,
       * PolicyPrincipal acquires its value from an organization unit or
       * identity, respectively.
       * For the Combined Classification type, the Principal is a marshalled
       * CombinedPrincipal.
       * </pre>
       *
       * <code>optional bytes principal = 2;</code>
       */
      public com.google.protobuf.ByteString getPrincipal() {
        return principal_;
      }
      /**
       * <pre>
       * Principal completes the policy principal definition. For the default
       * principal types, Principal can be either "Admin" or "Member".
       * For the ByOrganizationUnit/ByIdentity values of Classification,
       * PolicyPrincipal acquires its value from an organization unit or
       * identity, respectively.
       * For the Combined Classification type, the Principal is a marshalled
       * CombinedPrincipal.
       * </pre>
       *
       * <code>optional bytes principal = 2;</code>
       */
      public Builder setPrincipal(com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  
        principal_ = value;
        onChanged();
        return this;
      }
      /**
       * <pre>
       * Principal completes the policy principal definition. For the default
       * principal types, Principal can be either "Admin" or "Member".
       * For the ByOrganizationUnit/ByIdentity values of Classification,
       * PolicyPrincipal acquires its value from an organization unit or
       * identity, respectively.
       * For the Combined Classification type, the Principal is a marshalled
       * CombinedPrincipal.
       * </pre>
       *
       * <code>optional bytes principal = 2;</code>
       */
      public Builder clearPrincipal() {
        
        principal_ = getDefaultInstance().getPrincipal();
        onChanged();
        return this;
      }
      public final Builder setUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return this;
      }

      public final Builder mergeUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return this;
      }


      // @@protoc_insertion_point(builder_scope:common.MSPPrincipal)
    }

    // @@protoc_insertion_point(class_scope:common.MSPPrincipal)
    private static final org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal DEFAULT_INSTANCE;
    static {
      DEFAULT_INSTANCE = new org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal();
    }

    public static org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    private static final com.google.protobuf.Parser<MSPPrincipal>
        PARSER = new com.google.protobuf.AbstractParser<MSPPrincipal>() {
      public MSPPrincipal parsePartialFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
          return new MSPPrincipal(input, extensionRegistry);
      }
    };

    public static com.google.protobuf.Parser<MSPPrincipal> parser() {
      return PARSER;
    }

    @java.lang.Override
    public com.google.protobuf.Parser<MSPPrincipal> getParserForType() {
      return PARSER;
    }

    public org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal getDefaultInstanceForType() {
      return DEFAULT_INSTANCE;
    }

  }

  public interface OrganizationUnitOrBuilder extends
      // @@protoc_insertion_point(interface_extends:common.OrganizationUnit)
      com.google.protobuf.MessageOrBuilder {

    /**
     * <pre>
     * MSPIdentifier represents the identifier of the MSP this organization unit
     * refers to
     * </pre>
     *
     * <code>optional string msp_identifier = 1;</code>
     */
    java.lang.String getMspIdentifier();
    /**
     * <pre>
     * MSPIdentifier represents the identifier of the MSP this organization unit
     * refers to
     * </pre>
     *
     * <code>optional string msp_identifier = 1;</code>
     */
    com.google.protobuf.ByteString
        getMspIdentifierBytes();

    /**
     * <pre>
     * OrganizationUnitIdentifier defines the organizational unit under the
     * MSP identified with MSPIdentifier
     * </pre>
     *
     * <code>optional string organizational_unit_identifier = 2;</code>
     */
    java.lang.String getOrganizationalUnitIdentifier();
    /**
     * <pre>
     * OrganizationUnitIdentifier defines the organizational unit under the
     * MSP identified with MSPIdentifier
     * </pre>
     *
     * <code>optional string organizational_unit_identifier = 2;</code>
     */
    com.google.protobuf.ByteString
        getOrganizationalUnitIdentifierBytes();

    /**
     * <pre>
     * CertifiersIdentifier is the hash of certificates chain of trust
     * related to this organizational unit
     * </pre>
     *
     * <code>optional bytes certifiers_identifier = 3;</code>
     */
    com.google.protobuf.ByteString getCertifiersIdentifier();
  }
  /**
   * <pre>
   * OrganizationUnit governs the organization of the Principal
   * field of a policy principal when a specific organization unity members
   * are to be defined within a policy principal.
   * </pre>
   *
   * Protobuf type {@code common.OrganizationUnit}
   */
  public  static final class OrganizationUnit extends
      com.google.protobuf.GeneratedMessageV3 implements
      // @@protoc_insertion_point(message_implements:common.OrganizationUnit)
      OrganizationUnitOrBuilder {
    // Use OrganizationUnit.newBuilder() to construct.
    private OrganizationUnit(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
      super(builder);
    }
    private OrganizationUnit() {
      mspIdentifier_ = "";
      organizationalUnitIdentifier_ = "";
      certifiersIdentifier_ = com.google.protobuf.ByteString.EMPTY;
    }

    @java.lang.Override
    public final com.google.protobuf.UnknownFieldSet
    getUnknownFields() {
      return com.google.protobuf.UnknownFieldSet.getDefaultInstance();
    }
    private OrganizationUnit(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      this();
      int mutable_bitField0_ = 0;
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            default: {
              if (!input.skipField(tag)) {
                done = true;
              }
              break;
            }
            case 10: {
              java.lang.String s = input.readStringRequireUtf8();

              mspIdentifier_ = s;
              break;
            }
            case 18: {
              java.lang.String s = input.readStringRequireUtf8();

              organizationalUnitIdentifier_ = s;
              break;
            }
            case 26: {

              certifiersIdentifier_ = input.readBytes();
              break;
            }
          }
        }
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(this);
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(
            e).setUnfinishedMessage(this);
      } finally {
        makeExtensionsImmutable();
      }
    }
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return org.hyperledger.fabric.protos.common.MspPrincipal.internal_static_common_OrganizationUnit_descriptor;
    }

    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return org.hyperledger.fabric.protos.common.MspPrincipal.internal_static_common_OrganizationUnit_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              org.hyperledger.fabric.protos.common.MspPrincipal.OrganizationUnit.class, org.hyperledger.fabric.protos.common.MspPrincipal.OrganizationUnit.Builder.class);
    }

    public static final int MSP_IDENTIFIER_FIELD_NUMBER = 1;
    private volatile java.lang.Object mspIdentifier_;
    /**
     * <pre>
     * MSPIdentifier represents the identifier of the MSP this organization unit
     * refers to
     * </pre>
     *
     * <code>optional string msp_identifier = 1;</code>
     */
    public java.lang.String getMspIdentifier() {
      java.lang.Object ref = mspIdentifier_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        mspIdentifier_ = s;
        return s;
      }
    }
    /**
     * <pre>
     * MSPIdentifier represents the identifier of the MSP this organization unit
     * refers to
     * </pre>
     *
     * <code>optional string msp_identifier = 1;</code>
     */
    public com.google.protobuf.ByteString
        getMspIdentifierBytes() {
      java.lang.Object ref = mspIdentifier_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        mspIdentifier_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    public static final int ORGANIZATIONAL_UNIT_IDENTIFIER_FIELD_NUMBER = 2;
    private volatile java.lang.Object organizationalUnitIdentifier_;
    /**
     * <pre>
     * OrganizationUnitIdentifier defines the organizational unit under the
     * MSP identified with MSPIdentifier
     * </pre>
     *
     * <code>optional string organizational_unit_identifier = 2;</code>
     */
    public java.lang.String getOrganizationalUnitIdentifier() {
      java.lang.Object ref = organizationalUnitIdentifier_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        organizationalUnitIdentifier_ = s;
        return s;
      }
    }
    /**
     * <pre>
     * OrganizationUnitIdentifier defines the organizational unit under the
     * MSP identified with MSPIdentifier
     * </pre>
     *
     * <code>optional string organizational_unit_identifier = 2;</code>
     */
    public com.google.protobuf.ByteString
        getOrganizationalUnitIdentifierBytes() {
      java.lang.Object ref = organizationalUnitIdentifier_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        organizationalUnitIdentifier_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    public static final int CERTIFIERS_IDENTIFIER_FIELD_NUMBER = 3;
    private com.google.protobuf.ByteString certifiersIdentifier_;
    /**
     * <pre>
     * CertifiersIdentifier is the hash of certificates chain of trust
     * related to this organizational unit
     * </pre>
     *
     * <code>optional bytes certifiers_identifier = 3;</code>
     */
    public com.google.protobuf.ByteString getCertifiersIdentifier() {
      return certifiersIdentifier_;
    }

    private byte memoizedIsInitialized = -1;
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized == 1) return true;
      if (isInitialized == 0) return false;

      memoizedIsInitialized = 1;
      return true;
    }

    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      if (!getMspIdentifierBytes().isEmpty()) {
        com.google.protobuf.GeneratedMessageV3.writeString(output, 1, mspIdentifier_);
      }
      if (!getOrganizationalUnitIdentifierBytes().isEmpty()) {
        com.google.protobuf.GeneratedMessageV3.writeString(output, 2, organizationalUnitIdentifier_);
      }
      if (!certifiersIdentifier_.isEmpty()) {
        output.writeBytes(3, certifiersIdentifier_);
      }
    }

    public int getSerializedSize() {
      int size = memoizedSize;
      if (size != -1) return size;

      size = 0;
      if (!getMspIdentifierBytes().isEmpty()) {
        size += com.google.protobuf.GeneratedMessageV3.computeStringSize(1, mspIdentifier_);
      }
      if (!getOrganizationalUnitIdentifierBytes().isEmpty()) {
        size += com.google.protobuf.GeneratedMessageV3.computeStringSize(2, organizationalUnitIdentifier_);
      }
      if (!certifiersIdentifier_.isEmpty()) {
        size += com.google.protobuf.CodedOutputStream
          .computeBytesSize(3, certifiersIdentifier_);
      }
      memoizedSize = size;
      return size;
    }

    private static final long serialVersionUID = 0L;
    @java.lang.Override
    public boolean equals(final java.lang.Object obj) {
      if (obj == this) {
       return true;
      }
      if (!(obj instanceof org.hyperledger.fabric.protos.common.MspPrincipal.OrganizationUnit)) {
        return super.equals(obj);
      }
      org.hyperledger.fabric.protos.common.MspPrincipal.OrganizationUnit other = (org.hyperledger.fabric.protos.common.MspPrincipal.OrganizationUnit) obj;

      boolean result = true;
      result = result && getMspIdentifier()
          .equals(other.getMspIdentifier());
      result = result && getOrganizationalUnitIdentifier()
          .equals(other.getOrganizationalUnitIdentifier());
      result = result && getCertifiersIdentifier()
          .equals(other.getCertifiersIdentifier());
      return result;
    }

    @java.lang.Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptorForType().hashCode();
      hash = (37 * hash) + MSP_IDENTIFIER_FIELD_NUMBER;
      hash = (53 * hash) + getMspIdentifier().hashCode();
      hash = (37 * hash) + ORGANIZATIONAL_UNIT_IDENTIFIER_FIELD_NUMBER;
      hash = (53 * hash) + getOrganizationalUnitIdentifier().hashCode();
      hash = (37 * hash) + CERTIFIERS_IDENTIFIER_FIELD_NUMBER;
      hash = (53 * hash) + getCertifiersIdentifier().hashCode();
      hash = (29 * hash) + unknownFields.hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static org.hyperledger.fabric.protos.common.MspPrincipal.OrganizationUnit parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.hyperledger.fabric.protos.common.MspPrincipal.OrganizationUnit parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.hyperledger.fabric.protos.common.MspPrincipal.OrganizationUnit parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.hyperledger.fabric.protos.common.MspPrincipal.OrganizationUnit parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.hyperledger.fabric.protos.common.MspPrincipal.OrganizationUnit parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static org.hyperledger.fabric.protos.common.MspPrincipal.OrganizationUnit parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }
    public static org.hyperledger.fabric.protos.common.MspPrincipal.OrganizationUnit parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input);
    }
    public static org.hyperledger.fabric.protos.common.MspPrincipal.OrganizationUnit parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
    }
    public static org.hyperledger.fabric.protos.common.MspPrincipal.OrganizationUnit parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static org.hyperledger.fabric.protos.common.MspPrincipal.OrganizationUnit parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }

    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder() {
      return DEFAULT_INSTANCE.toBuilder();
    }
    public static Builder newBuilder(org.hyperledger.fabric.protos.common.MspPrincipal.OrganizationUnit prototype) {
      return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }
    public Builder toBuilder() {
      return this == DEFAULT_INSTANCE
          ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * <pre>
     * OrganizationUnit governs the organization of the Principal
     * field of a policy principal when a specific organization unity members
     * are to be defined within a policy principal.
     * </pre>
     *
     * Protobuf type {@code common.OrganizationUnit}
     */
    public static final class Builder extends
        com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
        // @@protoc_insertion_point(builder_implements:common.OrganizationUnit)
        org.hyperledger.fabric.protos.common.MspPrincipal.OrganizationUnitOrBuilder {
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return org.hyperledger.fabric.protos.common.MspPrincipal.internal_static_common_OrganizationUnit_descriptor;
      }

      protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return org.hyperledger.fabric.protos.common.MspPrincipal.internal_static_common_OrganizationUnit_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                org.hyperledger.fabric.protos.common.MspPrincipal.OrganizationUnit.class, org.hyperledger.fabric.protos.common.MspPrincipal.OrganizationUnit.Builder.class);
      }

      // Construct using org.hyperledger.fabric.protos.common.MspPrincipal.OrganizationUnit.newBuilder()
      private Builder() {
        maybeForceBuilderInitialization();
      }

      private Builder(
          com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
        super(parent);
        maybeForceBuilderInitialization();
      }
      private void maybeForceBuilderInitialization() {
        if (com.google.protobuf.GeneratedMessageV3
                .alwaysUseFieldBuilders) {
        }
      }
      public Builder clear() {
        super.clear();
        mspIdentifier_ = "";

        organizationalUnitIdentifier_ = "";

        certifiersIdentifier_ = com.google.protobuf.ByteString.EMPTY;

        return this;
      }

      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return org.hyperledger.fabric.protos.common.MspPrincipal.internal_static_common_OrganizationUnit_descriptor;
      }

      public org.hyperledger.fabric.protos.common.MspPrincipal.OrganizationUnit getDefaultInstanceForType() {
        return org.hyperledger.fabric.protos.common.MspPrincipal.OrganizationUnit.getDefaultInstance();
      }

      public org.hyperledger.fabric.protos.common.MspPrincipal.OrganizationUnit build() {
        org.hyperledger.fabric.protos.common.MspPrincipal.OrganizationUnit result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      public org.hyperledger.fabric.protos.common.MspPrincipal.OrganizationUnit buildPartial() {
        org.hyperledger.fabric.protos.common.MspPrincipal.OrganizationUnit result = new org.hyperledger.fabric.protos.common.MspPrincipal.OrganizationUnit(this);
        result.mspIdentifier_ = mspIdentifier_;
        result.organizationalUnitIdentifier_ = organizationalUnitIdentifier_;
        result.certifiersIdentifier_ = certifiersIdentifier_;
        onBuilt();
        return result;
      }

      public Builder clone() {
        return (Builder) super.clone();
      }
      public Builder setField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          Object value) {
        return (Builder) super.setField(field, value);
      }
      public Builder clearField(
          com.google.protobuf.Descriptors.FieldDescriptor field) {
        return (Builder) super.clearField(field);
      }
      public Builder clearOneof(
          com.google.protobuf.Descriptors.OneofDescriptor oneof) {
        return (Builder) super.clearOneof(oneof);
      }
      public Builder setRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          int index, Object value) {
        return (Builder) super.setRepeatedField(field, index, value);
      }
      public Builder addRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          Object value) {
        return (Builder) super.addRepeatedField(field, value);
      }
      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof org.hyperledger.fabric.protos.common.MspPrincipal.OrganizationUnit) {
          return mergeFrom((org.hyperledger.fabric.protos.common.MspPrincipal.OrganizationUnit)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(org.hyperledger.fabric.protos.common.MspPrincipal.OrganizationUnit other) {
        if (other == org.hyperledger.fabric.protos.common.MspPrincipal.OrganizationUnit.getDefaultInstance()) return this;
        if (!other.getMspIdentifier().isEmpty()) {
          mspIdentifier_ = other.mspIdentifier_;
          onChanged();
        }
        if (!other.getOrganizationalUnitIdentifier().isEmpty()) {
          organizationalUnitIdentifier_ = other.organizationalUnitIdentifier_;
          onChanged();
        }
        if (other.getCertifiersIdentifier() != com.google.protobuf.ByteString.EMPTY) {
          setCertifiersIdentifier(other.getCertifiersIdentifier());
        }
        onChanged();
        return this;
      }

      public final boolean isInitialized() {
        return true;
      }

      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        org.hyperledger.fabric.protos.common.MspPrincipal.OrganizationUnit parsedMessage = null;
        try {
          parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          parsedMessage = (org.hyperledger.fabric.protos.common.MspPrincipal.OrganizationUnit) e.getUnfinishedMessage();
          throw e.unwrapIOException();
        } finally {
          if (parsedMessage != null) {
            mergeFrom(parsedMessage);
          }
        }
        return this;
      }

      private java.lang.Object mspIdentifier_ = "";
      /**
       * <pre>
       * MSPIdentifier represents the identifier of the MSP this organization unit
       * refers to
       * </pre>
       *
       * <code>optional string msp_identifier = 1;</code>
       */
      public java.lang.String getMspIdentifier() {
        java.lang.Object ref = mspIdentifier_;
        if (!(ref instanceof java.lang.String)) {
          com.google.protobuf.ByteString bs =
              (com.google.protobuf.ByteString) ref;
          java.lang.String s = bs.toStringUtf8();
          mspIdentifier_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <pre>
       * MSPIdentifier represents the identifier of the MSP this organization unit
       * refers to
       * </pre>
       *
       * <code>optional string msp_identifier = 1;</code>
       */
      public com.google.protobuf.ByteString
          getMspIdentifierBytes() {
        java.lang.Object ref = mspIdentifier_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          mspIdentifier_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <pre>
       * MSPIdentifier represents the identifier of the MSP this organization unit
       * refers to
       * </pre>
       *
       * <code>optional string msp_identifier = 1;</code>
       */
      public Builder setMspIdentifier(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  
        mspIdentifier_ = value;
        onChanged();
        return this;
      }
      /**
       * <pre>
       * MSPIdentifier represents the identifier of the MSP this organization unit
       * refers to
       * </pre>
       *
       * <code>optional string msp_identifier = 1;</code>
       */
      public Builder clearMspIdentifier() {
        
        mspIdentifier_ = getDefaultInstance().getMspIdentifier();
        onChanged();
        return this;
      }
      /**
       * <pre>
       * MSPIdentifier represents the identifier of the MSP this organization unit
       * refers to
       * </pre>
       *
       * <code>optional string msp_identifier = 1;</code>
       */
      public Builder setMspIdentifierBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  checkByteStringIsUtf8(value);
        
        mspIdentifier_ = value;
        onChanged();
        return this;
      }

      private java.lang.Object organizationalUnitIdentifier_ = "";
      /**
       * <pre>
       * OrganizationUnitIdentifier defines the organizational unit under the
       * MSP identified with MSPIdentifier
       * </pre>
       *
       * <code>optional string organizational_unit_identifier = 2;</code>
       */
      public java.lang.String getOrganizationalUnitIdentifier() {
        java.lang.Object ref = organizationalUnitIdentifier_;
        if (!(ref instanceof java.lang.String)) {
          com.google.protobuf.ByteString bs =
              (com.google.protobuf.ByteString) ref;
          java.lang.String s = bs.toStringUtf8();
          organizationalUnitIdentifier_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <pre>
       * OrganizationUnitIdentifier defines the organizational unit under the
       * MSP identified with MSPIdentifier
       * </pre>
       *
       * <code>optional string organizational_unit_identifier = 2;</code>
       */
      public com.google.protobuf.ByteString
          getOrganizationalUnitIdentifierBytes() {
        java.lang.Object ref = organizationalUnitIdentifier_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          organizationalUnitIdentifier_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <pre>
       * OrganizationUnitIdentifier defines the organizational unit under the
       * MSP identified with MSPIdentifier
       * </pre>
       *
       * <code>optional string organizational_unit_identifier = 2;</code>
       */
      public Builder setOrganizationalUnitIdentifier(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  
        organizationalUnitIdentifier_ = value;
        onChanged();
        return this;
      }
      /**
       * <pre>
       * OrganizationUnitIdentifier defines the organizational unit under the
       * MSP identified with MSPIdentifier
       * </pre>
       *
       * <code>optional string organizational_unit_identifier = 2;</code>
       */
      public Builder clearOrganizationalUnitIdentifier() {
        
        organizationalUnitIdentifier_ = getDefaultInstance().getOrganizationalUnitIdentifier();
        onChanged();
        return this;
      }
      /**
       * <pre>
       * OrganizationUnitIdentifier defines the organizational unit under the
       * MSP identified with MSPIdentifier
       * </pre>
       *
       * <code>optional string organizational_unit_identifier = 2;</code>
       */
      public Builder setOrganizationalUnitIdentifierBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  checkByteStringIsUtf8(value);
        
        organizationalUnitIdentifier_ = value;
        onChanged();
        return this;
      }

      private com.google.protobuf.ByteString certifiersIdentifier_ = com.google.protobuf.ByteString.EMPTY;
      /**
       * <pre>
       * CertifiersIdentifier is the hash of certificates chain of trust
       * related to this organizational unit
       * </pre>
       *
       * <code>optional bytes certifiers_identifier = 3;</code>
       */
      public com.google.protobuf.ByteString getCertifiersIdentifier() {
        return certifiersIdentifier_;
      }
      /**
       * <pre>
       * CertifiersIdentifier is the hash of certificates chain of trust
       * related to this organizational unit
       * </pre>
       *
       * <code>optional bytes certifiers_identifier = 3;</code>
       */
      public Builder setCertifiersIdentifier(com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  
        certifiersIdentifier_ = value;
        onChanged();
        return this;
      }
      /**
       * <pre>
       * CertifiersIdentifier is the hash of certificates chain of trust
       * related to this organizational unit
       * </pre>
       *
       * <code>optional bytes certifiers_identifier = 3;</code>
       */
      public Builder clearCertifiersIdentifier() {
        
        certifiersIdentifier_ = getDefaultInstance().getCertifiersIdentifier();
        onChanged();
        return this;
      }
      public final Builder setUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return this;
      }

      public final Builder mergeUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return this;
      }


      // @@protoc_insertion_point(builder_scope:common.OrganizationUnit)
    }

    // @@protoc_insertion_point(class_scope:common.OrganizationUnit)
    private static final org.hyperledger.fabric.protos.common.MspPrincipal.OrganizationUnit DEFAULT_INSTANCE;
    static {
      DEFAULT_INSTANCE = new org.hyperledger.fabric.protos.common.MspPrincipal.OrganizationUnit();
    }

    public static org.hyperledger.fabric.protos.common.MspPrincipal.OrganizationUnit getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    private static final com.google.protobuf.Parser<OrganizationUnit>
        PARSER = new com.google.protobuf.AbstractParser<OrganizationUnit>() {
      public OrganizationUnit parsePartialFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
          return new OrganizationUnit(input, extensionRegistry);
      }
    };

    public static com.google.protobuf.Parser<OrganizationUnit> parser() {
      return PARSER;
    }

    @java.lang.Override
    public com.google.protobuf.Parser<OrganizationUnit> getParserForType() {
      return PARSER;
    }

    public org.hyperledger.fabric.protos.common.MspPrincipal.OrganizationUnit getDefaultInstanceForType() {
      return DEFAULT_INSTANCE;
    }

  }

  public interface MSPRoleOrBuilder extends
      // @@protoc_insertion_point(interface_extends:common.MSPRole)
      com.google.protobuf.MessageOrBuilder {

    /**
     * <pre>
     * MSPIdentifier represents the identifier of the MSP this principal
     * refers to
     * </pre>
     *
     * <code>optional string msp_identifier = 1;</code>
     */
    java.lang.String getMspIdentifier();
    /**
     * <pre>
     * MSPIdentifier represents the identifier of the MSP this principal
     * refers to
     * </pre>
     *
     * <code>optional string msp_identifier = 1;</code>
     */
    com.google.protobuf.ByteString
        getMspIdentifierBytes();

    /**
     * <pre>
     * MSPRoleType defines which of the available, pre-defined MSP-roles
     * an identiy should posess inside the MSP with identifier MSPidentifier
     * </pre>
     *
     * <code>optional .common.MSPRole.MSPRoleType role = 2;</code>
     */
    int getRoleValue();
    /**
     * <pre>
     * MSPRoleType defines which of the available, pre-defined MSP-roles
     * an identiy should posess inside the MSP with identifier MSPidentifier
     * </pre>
     *
     * <code>optional .common.MSPRole.MSPRoleType role = 2;</code>
     */
    org.hyperledger.fabric.protos.common.MspPrincipal.MSPRole.MSPRoleType getRole();
  }
  /**
   * <pre>
   * MSPRole governs the organization of the Principal
   * field of an MSPPrincipal when it aims to define one of the
   * two dedicated roles within an MSP: Admin and Members.
   * </pre>
   *
   * Protobuf type {@code common.MSPRole}
   */
  public  static final class MSPRole extends
      com.google.protobuf.GeneratedMessageV3 implements
      // @@protoc_insertion_point(message_implements:common.MSPRole)
      MSPRoleOrBuilder {
    // Use MSPRole.newBuilder() to construct.
    private MSPRole(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
      super(builder);
    }
    private MSPRole() {
      mspIdentifier_ = "";
      role_ = 0;
    }

    @java.lang.Override
    public final com.google.protobuf.UnknownFieldSet
    getUnknownFields() {
      return com.google.protobuf.UnknownFieldSet.getDefaultInstance();
    }
    private MSPRole(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      this();
      int mutable_bitField0_ = 0;
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            default: {
              if (!input.skipField(tag)) {
                done = true;
              }
              break;
            }
            case 10: {
              java.lang.String s = input.readStringRequireUtf8();

              mspIdentifier_ = s;
              break;
            }
            case 16: {
              int rawValue = input.readEnum();

              role_ = rawValue;
              break;
            }
          }
        }
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(this);
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(
            e).setUnfinishedMessage(this);
      } finally {
        makeExtensionsImmutable();
      }
    }
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return org.hyperledger.fabric.protos.common.MspPrincipal.internal_static_common_MSPRole_descriptor;
    }

    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return org.hyperledger.fabric.protos.common.MspPrincipal.internal_static_common_MSPRole_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              org.hyperledger.fabric.protos.common.MspPrincipal.MSPRole.class, org.hyperledger.fabric.protos.common.MspPrincipal.MSPRole.Builder.class);
    }

    /**
     * Protobuf enum {@code common.MSPRole.MSPRoleType}
     */
    public enum MSPRoleType
        implements com.google.protobuf.ProtocolMessageEnum {
      /**
       * <pre>
       * Represents an MSP Member
       * </pre>
       *
       * <code>MEMBER = 0;</code>
       */
      MEMBER(0),
      /**
       * <pre>
       * Represents an MSP Admin
       * </pre>
       *
       * <code>ADMIN = 1;</code>
       */
      ADMIN(1),
      /**
       * <pre>
       * Represents an MSP Client
       * </pre>
       *
       * <code>CLIENT = 2;</code>
       */
      CLIENT(2),
      /**
       * <pre>
       * Represents an MSP Peer
       * </pre>
       *
       * <code>PEER = 3;</code>
       */
      PEER(3),
      UNRECOGNIZED(-1),
      ;

      /**
       * <pre>
       * Represents an MSP Member
       * </pre>
       *
       * <code>MEMBER = 0;</code>
       */
      public static final int MEMBER_VALUE = 0;
      /**
       * <pre>
       * Represents an MSP Admin
       * </pre>
       *
       * <code>ADMIN = 1;</code>
       */
      public static final int ADMIN_VALUE = 1;
      /**
       * <pre>
       * Represents an MSP Client
       * </pre>
       *
       * <code>CLIENT = 2;</code>
       */
      public static final int CLIENT_VALUE = 2;
      /**
       * <pre>
       * Represents an MSP Peer
       * </pre>
       *
       * <code>PEER = 3;</code>
       */
      public static final int PEER_VALUE = 3;


      public final int getNumber() {
        if (this == UNRECOGNIZED) {
          throw new java.lang.IllegalArgumentException(
              "Can't get the number of an unknown enum value.");
        }
        return value;
      }

      /**
       * @deprecated Use {@link #forNumber(int)} instead.
       */
      @java.lang.Deprecated
      public static MSPRoleType valueOf(int value) {
        return forNumber(value);
      }

      public static MSPRoleType forNumber(int value) {
        switch (value) {
          case 0: return MEMBER;
          case 1: return ADMIN;
          case 2: return CLIENT;
          case 3: return PEER;
          default: return null;
        }
      }

      public static com.google.protobuf.Internal.EnumLiteMap<MSPRoleType>
          internalGetValueMap() {
        return internalValueMap;
      }
      private static final com.google.protobuf.Internal.EnumLiteMap<
          MSPRoleType> internalValueMap =
            new com.google.protobuf.Internal.EnumLiteMap<MSPRoleType>() {
              public MSPRoleType findValueByNumber(int number) {
                return MSPRoleType.forNumber(number);
              }
            };

      public final com.google.protobuf.Descriptors.EnumValueDescriptor
          getValueDescriptor() {
        return getDescriptor().getValues().get(ordinal());
      }
      public final com.google.protobuf.Descriptors.EnumDescriptor
          getDescriptorForType() {
        return getDescriptor();
      }
      public static final com.google.protobuf.Descriptors.EnumDescriptor
          getDescriptor() {
        return org.hyperledger.fabric.protos.common.MspPrincipal.MSPRole.getDescriptor().getEnumTypes().get(0);
      }

      private static final MSPRoleType[] VALUES = values();

      public static MSPRoleType valueOf(
          com.google.protobuf.Descriptors.EnumValueDescriptor desc) {
        if (desc.getType() != getDescriptor()) {
          throw new java.lang.IllegalArgumentException(
            "EnumValueDescriptor is not for this type.");
        }
        if (desc.getIndex() == -1) {
          return UNRECOGNIZED;
        }
        return VALUES[desc.getIndex()];
      }

      private final int value;

      private MSPRoleType(int value) {
        this.value = value;
      }

      // @@protoc_insertion_point(enum_scope:common.MSPRole.MSPRoleType)
    }

    public static final int MSP_IDENTIFIER_FIELD_NUMBER = 1;
    private volatile java.lang.Object mspIdentifier_;
    /**
     * <pre>
     * MSPIdentifier represents the identifier of the MSP this principal
     * refers to
     * </pre>
     *
     * <code>optional string msp_identifier = 1;</code>
     */
    public java.lang.String getMspIdentifier() {
      java.lang.Object ref = mspIdentifier_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        mspIdentifier_ = s;
        return s;
      }
    }
    /**
     * <pre>
     * MSPIdentifier represents the identifier of the MSP this principal
     * refers to
     * </pre>
     *
     * <code>optional string msp_identifier = 1;</code>
     */
    public com.google.protobuf.ByteString
        getMspIdentifierBytes() {
      java.lang.Object ref = mspIdentifier_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        mspIdentifier_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    public static final int ROLE_FIELD_NUMBER = 2;
    private int role_;
    /**
     * <pre>
     * MSPRoleType defines which of the available, pre-defined MSP-roles
     * an identiy should posess inside the MSP with identifier MSPidentifier
     * </pre>
     *
     * <code>optional .common.MSPRole.MSPRoleType role = 2;</code>
     */
    public int getRoleValue() {
      return role_;
    }
    /**
     * <pre>
     * MSPRoleType defines which of the available, pre-defined MSP-roles
     * an identiy should posess inside the MSP with identifier MSPidentifier
     * </pre>
     *
     * <code>optional .common.MSPRole.MSPRoleType role = 2;</code>
     */
    public org.hyperledger.fabric.protos.common.MspPrincipal.MSPRole.MSPRoleType getRole() {
      org.hyperledger.fabric.protos.common.MspPrincipal.MSPRole.MSPRoleType result = org.hyperledger.fabric.protos.common.MspPrincipal.MSPRole.MSPRoleType.valueOf(role_);
      return result == null ? org.hyperledger.fabric.protos.common.MspPrincipal.MSPRole.MSPRoleType.UNRECOGNIZED : result;
    }

    private byte memoizedIsInitialized = -1;
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized == 1) return true;
      if (isInitialized == 0) return false;

      memoizedIsInitialized = 1;
      return true;
    }

    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      if (!getMspIdentifierBytes().isEmpty()) {
        com.google.protobuf.GeneratedMessageV3.writeString(output, 1, mspIdentifier_);
      }
      if (role_ != org.hyperledger.fabric.protos.common.MspPrincipal.MSPRole.MSPRoleType.MEMBER.getNumber()) {
        output.writeEnum(2, role_);
      }
    }

    public int getSerializedSize() {
      int size = memoizedSize;
      if (size != -1) return size;

      size = 0;
      if (!getMspIdentifierBytes().isEmpty()) {
        size += com.google.protobuf.GeneratedMessageV3.computeStringSize(1, mspIdentifier_);
      }
      if (role_ != org.hyperledger.fabric.protos.common.MspPrincipal.MSPRole.MSPRoleType.MEMBER.getNumber()) {
        size += com.google.protobuf.CodedOutputStream
          .computeEnumSize(2, role_);
      }
      memoizedSize = size;
      return size;
    }

    private static final long serialVersionUID = 0L;
    @java.lang.Override
    public boolean equals(final java.lang.Object obj) {
      if (obj == this) {
       return true;
      }
      if (!(obj instanceof org.hyperledger.fabric.protos.common.MspPrincipal.MSPRole)) {
        return super.equals(obj);
      }
      org.hyperledger.fabric.protos.common.MspPrincipal.MSPRole other = (org.hyperledger.fabric.protos.common.MspPrincipal.MSPRole) obj;

      boolean result = true;
      result = result && getMspIdentifier()
          .equals(other.getMspIdentifier());
      result = result && role_ == other.role_;
      return result;
    }

    @java.lang.Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptorForType().hashCode();
      hash = (37 * hash) + MSP_IDENTIFIER_FIELD_NUMBER;
      hash = (53 * hash) + getMspIdentifier().hashCode();
      hash = (37 * hash) + ROLE_FIELD_NUMBER;
      hash = (53 * hash) + role_;
      hash = (29 * hash) + unknownFields.hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static org.hyperledger.fabric.protos.common.MspPrincipal.MSPRole parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.hyperledger.fabric.protos.common.MspPrincipal.MSPRole parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.hyperledger.fabric.protos.common.MspPrincipal.MSPRole parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.hyperledger.fabric.protos.common.MspPrincipal.MSPRole parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.hyperledger.fabric.protos.common.MspPrincipal.MSPRole parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static org.hyperledger.fabric.protos.common.MspPrincipal.MSPRole parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }
    public static org.hyperledger.fabric.protos.common.MspPrincipal.MSPRole parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input);
    }
    public static org.hyperledger.fabric.protos.common.MspPrincipal.MSPRole parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
    }
    public static org.hyperledger.fabric.protos.common.MspPrincipal.MSPRole parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static org.hyperledger.fabric.protos.common.MspPrincipal.MSPRole parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }

    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder() {
      return DEFAULT_INSTANCE.toBuilder();
    }
    public static Builder newBuilder(org.hyperledger.fabric.protos.common.MspPrincipal.MSPRole prototype) {
      return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }
    public Builder toBuilder() {
      return this == DEFAULT_INSTANCE
          ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * <pre>
     * MSPRole governs the organization of the Principal
     * field of an MSPPrincipal when it aims to define one of the
     * two dedicated roles within an MSP: Admin and Members.
     * </pre>
     *
     * Protobuf type {@code common.MSPRole}
     */
    public static final class Builder extends
        com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
        // @@protoc_insertion_point(builder_implements:common.MSPRole)
        org.hyperledger.fabric.protos.common.MspPrincipal.MSPRoleOrBuilder {
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return org.hyperledger.fabric.protos.common.MspPrincipal.internal_static_common_MSPRole_descriptor;
      }

      protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return org.hyperledger.fabric.protos.common.MspPrincipal.internal_static_common_MSPRole_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                org.hyperledger.fabric.protos.common.MspPrincipal.MSPRole.class, org.hyperledger.fabric.protos.common.MspPrincipal.MSPRole.Builder.class);
      }

      // Construct using org.hyperledger.fabric.protos.common.MspPrincipal.MSPRole.newBuilder()
      private Builder() {
        maybeForceBuilderInitialization();
      }

      private Builder(
          com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
        super(parent);
        maybeForceBuilderInitialization();
      }
      private void maybeForceBuilderInitialization() {
        if (com.google.protobuf.GeneratedMessageV3
                .alwaysUseFieldBuilders) {
        }
      }
      public Builder clear() {
        super.clear();
        mspIdentifier_ = "";

        role_ = 0;

        return this;
      }

      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return org.hyperledger.fabric.protos.common.MspPrincipal.internal_static_common_MSPRole_descriptor;
      }

      public org.hyperledger.fabric.protos.common.MspPrincipal.MSPRole getDefaultInstanceForType() {
        return org.hyperledger.fabric.protos.common.MspPrincipal.MSPRole.getDefaultInstance();
      }

      public org.hyperledger.fabric.protos.common.MspPrincipal.MSPRole build() {
        org.hyperledger.fabric.protos.common.MspPrincipal.MSPRole result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      public org.hyperledger.fabric.protos.common.MspPrincipal.MSPRole buildPartial() {
        org.hyperledger.fabric.protos.common.MspPrincipal.MSPRole result = new org.hyperledger.fabric.protos.common.MspPrincipal.MSPRole(this);
        result.mspIdentifier_ = mspIdentifier_;
        result.role_ = role_;
        onBuilt();
        return result;
      }

      public Builder clone() {
        return (Builder) super.clone();
      }
      public Builder setField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          Object value) {
        return (Builder) super.setField(field, value);
      }
      public Builder clearField(
          com.google.protobuf.Descriptors.FieldDescriptor field) {
        return (Builder) super.clearField(field);
      }
      public Builder clearOneof(
          com.google.protobuf.Descriptors.OneofDescriptor oneof) {
        return (Builder) super.clearOneof(oneof);
      }
      public Builder setRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          int index, Object value) {
        return (Builder) super.setRepeatedField(field, index, value);
      }
      public Builder addRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          Object value) {
        return (Builder) super.addRepeatedField(field, value);
      }
      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof org.hyperledger.fabric.protos.common.MspPrincipal.MSPRole) {
          return mergeFrom((org.hyperledger.fabric.protos.common.MspPrincipal.MSPRole)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(org.hyperledger.fabric.protos.common.MspPrincipal.MSPRole other) {
        if (other == org.hyperledger.fabric.protos.common.MspPrincipal.MSPRole.getDefaultInstance()) return this;
        if (!other.getMspIdentifier().isEmpty()) {
          mspIdentifier_ = other.mspIdentifier_;
          onChanged();
        }
        if (other.role_ != 0) {
          setRoleValue(other.getRoleValue());
        }
        onChanged();
        return this;
      }

      public final boolean isInitialized() {
        return true;
      }

      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        org.hyperledger.fabric.protos.common.MspPrincipal.MSPRole parsedMessage = null;
        try {
          parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          parsedMessage = (org.hyperledger.fabric.protos.common.MspPrincipal.MSPRole) e.getUnfinishedMessage();
          throw e.unwrapIOException();
        } finally {
          if (parsedMessage != null) {
            mergeFrom(parsedMessage);
          }
        }
        return this;
      }

      private java.lang.Object mspIdentifier_ = "";
      /**
       * <pre>
       * MSPIdentifier represents the identifier of the MSP this principal
       * refers to
       * </pre>
       *
       * <code>optional string msp_identifier = 1;</code>
       */
      public java.lang.String getMspIdentifier() {
        java.lang.Object ref = mspIdentifier_;
        if (!(ref instanceof java.lang.String)) {
          com.google.protobuf.ByteString bs =
              (com.google.protobuf.ByteString) ref;
          java.lang.String s = bs.toStringUtf8();
          mspIdentifier_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <pre>
       * MSPIdentifier represents the identifier of the MSP this principal
       * refers to
       * </pre>
       *
       * <code>optional string msp_identifier = 1;</code>
       */
      public com.google.protobuf.ByteString
          getMspIdentifierBytes() {
        java.lang.Object ref = mspIdentifier_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          mspIdentifier_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <pre>
       * MSPIdentifier represents the identifier of the MSP this principal
       * refers to
       * </pre>
       *
       * <code>optional string msp_identifier = 1;</code>
       */
      public Builder setMspIdentifier(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  
        mspIdentifier_ = value;
        onChanged();
        return this;
      }
      /**
       * <pre>
       * MSPIdentifier represents the identifier of the MSP this principal
       * refers to
       * </pre>
       *
       * <code>optional string msp_identifier = 1;</code>
       */
      public Builder clearMspIdentifier() {
        
        mspIdentifier_ = getDefaultInstance().getMspIdentifier();
        onChanged();
        return this;
      }
      /**
       * <pre>
       * MSPIdentifier represents the identifier of the MSP this principal
       * refers to
       * </pre>
       *
       * <code>optional string msp_identifier = 1;</code>
       */
      public Builder setMspIdentifierBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  checkByteStringIsUtf8(value);
        
        mspIdentifier_ = value;
        onChanged();
        return this;
      }

      private int role_ = 0;
      /**
       * <pre>
       * MSPRoleType defines which of the available, pre-defined MSP-roles
       * an identiy should posess inside the MSP with identifier MSPidentifier
       * </pre>
       *
       * <code>optional .common.MSPRole.MSPRoleType role = 2;</code>
       */
      public int getRoleValue() {
        return role_;
      }
      /**
       * <pre>
       * MSPRoleType defines which of the available, pre-defined MSP-roles
       * an identiy should posess inside the MSP with identifier MSPidentifier
       * </pre>
       *
       * <code>optional .common.MSPRole.MSPRoleType role = 2;</code>
       */
      public Builder setRoleValue(int value) {
        role_ = value;
        onChanged();
        return this;
      }
      /**
       * <pre>
       * MSPRoleType defines which of the available, pre-defined MSP-roles
       * an identiy should posess inside the MSP with identifier MSPidentifier
       * </pre>
       *
       * <code>optional .common.MSPRole.MSPRoleType role = 2;</code>
       */
      public org.hyperledger.fabric.protos.common.MspPrincipal.MSPRole.MSPRoleType getRole() {
        org.hyperledger.fabric.protos.common.MspPrincipal.MSPRole.MSPRoleType result = org.hyperledger.fabric.protos.common.MspPrincipal.MSPRole.MSPRoleType.valueOf(role_);
        return result == null ? org.hyperledger.fabric.protos.common.MspPrincipal.MSPRole.MSPRoleType.UNRECOGNIZED : result;
      }
      /**
       * <pre>
       * MSPRoleType defines which of the available, pre-defined MSP-roles
       * an identiy should posess inside the MSP with identifier MSPidentifier
       * </pre>
       *
       * <code>optional .common.MSPRole.MSPRoleType role = 2;</code>
       */
      public Builder setRole(org.hyperledger.fabric.protos.common.MspPrincipal.MSPRole.MSPRoleType value) {
        if (value == null) {
          throw new NullPointerException();
        }
        
        role_ = value.getNumber();
        onChanged();
        return this;
      }
      /**
       * <pre>
       * MSPRoleType defines which of the available, pre-defined MSP-roles
       * an identiy should posess inside the MSP with identifier MSPidentifier
       * </pre>
       *
       * <code>optional .common.MSPRole.MSPRoleType role = 2;</code>
       */
      public Builder clearRole() {
        
        role_ = 0;
        onChanged();
        return this;
      }
      public final Builder setUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return this;
      }

      public final Builder mergeUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return this;
      }


      // @@protoc_insertion_point(builder_scope:common.MSPRole)
    }

    // @@protoc_insertion_point(class_scope:common.MSPRole)
    private static final org.hyperledger.fabric.protos.common.MspPrincipal.MSPRole DEFAULT_INSTANCE;
    static {
      DEFAULT_INSTANCE = new org.hyperledger.fabric.protos.common.MspPrincipal.MSPRole();
    }

    public static org.hyperledger.fabric.protos.common.MspPrincipal.MSPRole getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    private static final com.google.protobuf.Parser<MSPRole>
        PARSER = new com.google.protobuf.AbstractParser<MSPRole>() {
      public MSPRole parsePartialFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
          return new MSPRole(input, extensionRegistry);
      }
    };

    public static com.google.protobuf.Parser<MSPRole> parser() {
      return PARSER;
    }

    @java.lang.Override
    public com.google.protobuf.Parser<MSPRole> getParserForType() {
      return PARSER;
    }

    public org.hyperledger.fabric.protos.common.MspPrincipal.MSPRole getDefaultInstanceForType() {
      return DEFAULT_INSTANCE;
    }

  }

  public interface MSPIdentityAnonymityOrBuilder extends
      // @@protoc_insertion_point(interface_extends:common.MSPIdentityAnonymity)
      com.google.protobuf.MessageOrBuilder {

    /**
     * <code>optional .common.MSPIdentityAnonymity.MSPIdentityAnonymityType anonymity_type = 1;</code>
     */
    int getAnonymityTypeValue();
    /**
     * <code>optional .common.MSPIdentityAnonymity.MSPIdentityAnonymityType anonymity_type = 1;</code>
     */
    org.hyperledger.fabric.protos.common.MspPrincipal.MSPIdentityAnonymity.MSPIdentityAnonymityType getAnonymityType();
  }
  /**
   * <pre>
   * MSPIdentityAnonymity can be used to enforce an identity to be anonymous or nominal.
   * </pre>
   *
   * Protobuf type {@code common.MSPIdentityAnonymity}
   */
  public  static final class MSPIdentityAnonymity extends
      com.google.protobuf.GeneratedMessageV3 implements
      // @@protoc_insertion_point(message_implements:common.MSPIdentityAnonymity)
      MSPIdentityAnonymityOrBuilder {
    // Use MSPIdentityAnonymity.newBuilder() to construct.
    private MSPIdentityAnonymity(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
      super(builder);
    }
    private MSPIdentityAnonymity() {
      anonymityType_ = 0;
    }

    @java.lang.Override
    public final com.google.protobuf.UnknownFieldSet
    getUnknownFields() {
      return com.google.protobuf.UnknownFieldSet.getDefaultInstance();
    }
    private MSPIdentityAnonymity(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      this();
      int mutable_bitField0_ = 0;
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            default: {
              if (!input.skipField(tag)) {
                done = true;
              }
              break;
            }
            case 8: {
              int rawValue = input.readEnum();

              anonymityType_ = rawValue;
              break;
            }
          }
        }
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(this);
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(
            e).setUnfinishedMessage(this);
      } finally {
        makeExtensionsImmutable();
      }
    }
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return org.hyperledger.fabric.protos.common.MspPrincipal.internal_static_common_MSPIdentityAnonymity_descriptor;
    }

    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return org.hyperledger.fabric.protos.common.MspPrincipal.internal_static_common_MSPIdentityAnonymity_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              org.hyperledger.fabric.protos.common.MspPrincipal.MSPIdentityAnonymity.class, org.hyperledger.fabric.protos.common.MspPrincipal.MSPIdentityAnonymity.Builder.class);
    }

    /**
     * Protobuf enum {@code common.MSPIdentityAnonymity.MSPIdentityAnonymityType}
     */
    public enum MSPIdentityAnonymityType
        implements com.google.protobuf.ProtocolMessageEnum {
      /**
       * <pre>
       * Represents a nominal MSP Identity
       * </pre>
       *
       * <code>NOMINAL = 0;</code>
       */
      NOMINAL(0),
      /**
       * <pre>
       * Represents an anonymous MSP Identity
       * </pre>
       *
       * <code>ANONYMOUS = 1;</code>
       */
      ANONYMOUS(1),
      UNRECOGNIZED(-1),
      ;

      /**
       * <pre>
       * Represents a nominal MSP Identity
       * </pre>
       *
       * <code>NOMINAL = 0;</code>
       */
      public static final int NOMINAL_VALUE = 0;
      /**
       * <pre>
       * Represents an anonymous MSP Identity
       * </pre>
       *
       * <code>ANONYMOUS = 1;</code>
       */
      public static final int ANONYMOUS_VALUE = 1;


      public final int getNumber() {
        if (this == UNRECOGNIZED) {
          throw new java.lang.IllegalArgumentException(
              "Can't get the number of an unknown enum value.");
        }
        return value;
      }

      /**
       * @deprecated Use {@link #forNumber(int)} instead.
       */
      @java.lang.Deprecated
      public static MSPIdentityAnonymityType valueOf(int value) {
        return forNumber(value);
      }

      public static MSPIdentityAnonymityType forNumber(int value) {
        switch (value) {
          case 0: return NOMINAL;
          case 1: return ANONYMOUS;
          default: return null;
        }
      }

      public static com.google.protobuf.Internal.EnumLiteMap<MSPIdentityAnonymityType>
          internalGetValueMap() {
        return internalValueMap;
      }
      private static final com.google.protobuf.Internal.EnumLiteMap<
          MSPIdentityAnonymityType> internalValueMap =
            new com.google.protobuf.Internal.EnumLiteMap<MSPIdentityAnonymityType>() {
              public MSPIdentityAnonymityType findValueByNumber(int number) {
                return MSPIdentityAnonymityType.forNumber(number);
              }
            };

      public final com.google.protobuf.Descriptors.EnumValueDescriptor
          getValueDescriptor() {
        return getDescriptor().getValues().get(ordinal());
      }
      public final com.google.protobuf.Descriptors.EnumDescriptor
          getDescriptorForType() {
        return getDescriptor();
      }
      public static final com.google.protobuf.Descriptors.EnumDescriptor
          getDescriptor() {
        return org.hyperledger.fabric.protos.common.MspPrincipal.MSPIdentityAnonymity.getDescriptor().getEnumTypes().get(0);
      }

      private static final MSPIdentityAnonymityType[] VALUES = values();

      public static MSPIdentityAnonymityType valueOf(
          com.google.protobuf.Descriptors.EnumValueDescriptor desc) {
        if (desc.getType() != getDescriptor()) {
          throw new java.lang.IllegalArgumentException(
            "EnumValueDescriptor is not for this type.");
        }
        if (desc.getIndex() == -1) {
          return UNRECOGNIZED;
        }
        return VALUES[desc.getIndex()];
      }

      private final int value;

      private MSPIdentityAnonymityType(int value) {
        this.value = value;
      }

      // @@protoc_insertion_point(enum_scope:common.MSPIdentityAnonymity.MSPIdentityAnonymityType)
    }

    public static final int ANONYMITY_TYPE_FIELD_NUMBER = 1;
    private int anonymityType_;
    /**
     * <code>optional .common.MSPIdentityAnonymity.MSPIdentityAnonymityType anonymity_type = 1;</code>
     */
    public int getAnonymityTypeValue() {
      return anonymityType_;
    }
    /**
     * <code>optional .common.MSPIdentityAnonymity.MSPIdentityAnonymityType anonymity_type = 1;</code>
     */
    public org.hyperledger.fabric.protos.common.MspPrincipal.MSPIdentityAnonymity.MSPIdentityAnonymityType getAnonymityType() {
      org.hyperledger.fabric.protos.common.MspPrincipal.MSPIdentityAnonymity.MSPIdentityAnonymityType result = org.hyperledger.fabric.protos.common.MspPrincipal.MSPIdentityAnonymity.MSPIdentityAnonymityType.valueOf(anonymityType_);
      return result == null ? org.hyperledger.fabric.protos.common.MspPrincipal.MSPIdentityAnonymity.MSPIdentityAnonymityType.UNRECOGNIZED : result;
    }

    private byte memoizedIsInitialized = -1;
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized == 1) return true;
      if (isInitialized == 0) return false;

      memoizedIsInitialized = 1;
      return true;
    }

    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      if (anonymityType_ != org.hyperledger.fabric.protos.common.MspPrincipal.MSPIdentityAnonymity.MSPIdentityAnonymityType.NOMINAL.getNumber()) {
        output.writeEnum(1, anonymityType_);
      }
    }

    public int getSerializedSize() {
      int size = memoizedSize;
      if (size != -1) return size;

      size = 0;
      if (anonymityType_ != org.hyperledger.fabric.protos.common.MspPrincipal.MSPIdentityAnonymity.MSPIdentityAnonymityType.NOMINAL.getNumber()) {
        size += com.google.protobuf.CodedOutputStream
          .computeEnumSize(1, anonymityType_);
      }
      memoizedSize = size;
      return size;
    }

    private static final long serialVersionUID = 0L;
    @java.lang.Override
    public boolean equals(final java.lang.Object obj) {
      if (obj == this) {
       return true;
      }
      if (!(obj instanceof org.hyperledger.fabric.protos.common.MspPrincipal.MSPIdentityAnonymity)) {
        return super.equals(obj);
      }
      org.hyperledger.fabric.protos.common.MspPrincipal.MSPIdentityAnonymity other = (org.hyperledger.fabric.protos.common.MspPrincipal.MSPIdentityAnonymity) obj;

      boolean result = true;
      result = result && anonymityType_ == other.anonymityType_;
      return result;
    }

    @java.lang.Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptorForType().hashCode();
      hash = (37 * hash) + ANONYMITY_TYPE_FIELD_NUMBER;
      hash = (53 * hash) + anonymityType_;
      hash = (29 * hash) + unknownFields.hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static org.hyperledger.fabric.protos.common.MspPrincipal.MSPIdentityAnonymity parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.hyperledger.fabric.protos.common.MspPrincipal.MSPIdentityAnonymity parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.hyperledger.fabric.protos.common.MspPrincipal.MSPIdentityAnonymity parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.hyperledger.fabric.protos.common.MspPrincipal.MSPIdentityAnonymity parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.hyperledger.fabric.protos.common.MspPrincipal.MSPIdentityAnonymity parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static org.hyperledger.fabric.protos.common.MspPrincipal.MSPIdentityAnonymity parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }
    public static org.hyperledger.fabric.protos.common.MspPrincipal.MSPIdentityAnonymity parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input);
    }
    public static org.hyperledger.fabric.protos.common.MspPrincipal.MSPIdentityAnonymity parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
    }
    public static org.hyperledger.fabric.protos.common.MspPrincipal.MSPIdentityAnonymity parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static org.hyperledger.fabric.protos.common.MspPrincipal.MSPIdentityAnonymity parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }

    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder() {
      return DEFAULT_INSTANCE.toBuilder();
    }
    public static Builder newBuilder(org.hyperledger.fabric.protos.common.MspPrincipal.MSPIdentityAnonymity prototype) {
      return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }
    public Builder toBuilder() {
      return this == DEFAULT_INSTANCE
          ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * <pre>
     * MSPIdentityAnonymity can be used to enforce an identity to be anonymous or nominal.
     * </pre>
     *
     * Protobuf type {@code common.MSPIdentityAnonymity}
     */
    public static final class Builder extends
        com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
        // @@protoc_insertion_point(builder_implements:common.MSPIdentityAnonymity)
        org.hyperledger.fabric.protos.common.MspPrincipal.MSPIdentityAnonymityOrBuilder {
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return org.hyperledger.fabric.protos.common.MspPrincipal.internal_static_common_MSPIdentityAnonymity_descriptor;
      }

      protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return org.hyperledger.fabric.protos.common.MspPrincipal.internal_static_common_MSPIdentityAnonymity_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                org.hyperledger.fabric.protos.common.MspPrincipal.MSPIdentityAnonymity.class, org.hyperledger.fabric.protos.common.MspPrincipal.MSPIdentityAnonymity.Builder.class);
      }

      // Construct using org.hyperledger.fabric.protos.common.MspPrincipal.MSPIdentityAnonymity.newBuilder()
      private Builder() {
        maybeForceBuilderInitialization();
      }

      private Builder(
          com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
        super(parent);
        maybeForceBuilderInitialization();
      }
      private void maybeForceBuilderInitialization() {
        if (com.google.protobuf.GeneratedMessageV3
                .alwaysUseFieldBuilders) {
        }
      }
      public Builder clear() {
        super.clear();
        anonymityType_ = 0;

        return this;
      }

      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return org.hyperledger.fabric.protos.common.MspPrincipal.internal_static_common_MSPIdentityAnonymity_descriptor;
      }

      public org.hyperledger.fabric.protos.common.MspPrincipal.MSPIdentityAnonymity getDefaultInstanceForType() {
        return org.hyperledger.fabric.protos.common.MspPrincipal.MSPIdentityAnonymity.getDefaultInstance();
      }

      public org.hyperledger.fabric.protos.common.MspPrincipal.MSPIdentityAnonymity build() {
        org.hyperledger.fabric.protos.common.MspPrincipal.MSPIdentityAnonymity result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      public org.hyperledger.fabric.protos.common.MspPrincipal.MSPIdentityAnonymity buildPartial() {
        org.hyperledger.fabric.protos.common.MspPrincipal.MSPIdentityAnonymity result = new org.hyperledger.fabric.protos.common.MspPrincipal.MSPIdentityAnonymity(this);
        result.anonymityType_ = anonymityType_;
        onBuilt();
        return result;
      }

      public Builder clone() {
        return (Builder) super.clone();
      }
      public Builder setField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          Object value) {
        return (Builder) super.setField(field, value);
      }
      public Builder clearField(
          com.google.protobuf.Descriptors.FieldDescriptor field) {
        return (Builder) super.clearField(field);
      }
      public Builder clearOneof(
          com.google.protobuf.Descriptors.OneofDescriptor oneof) {
        return (Builder) super.clearOneof(oneof);
      }
      public Builder setRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          int index, Object value) {
        return (Builder) super.setRepeatedField(field, index, value);
      }
      public Builder addRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          Object value) {
        return (Builder) super.addRepeatedField(field, value);
      }
      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof org.hyperledger.fabric.protos.common.MspPrincipal.MSPIdentityAnonymity) {
          return mergeFrom((org.hyperledger.fabric.protos.common.MspPrincipal.MSPIdentityAnonymity)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(org.hyperledger.fabric.protos.common.MspPrincipal.MSPIdentityAnonymity other) {
        if (other == org.hyperledger.fabric.protos.common.MspPrincipal.MSPIdentityAnonymity.getDefaultInstance()) return this;
        if (other.anonymityType_ != 0) {
          setAnonymityTypeValue(other.getAnonymityTypeValue());
        }
        onChanged();
        return this;
      }

      public final boolean isInitialized() {
        return true;
      }

      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        org.hyperledger.fabric.protos.common.MspPrincipal.MSPIdentityAnonymity parsedMessage = null;
        try {
          parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          parsedMessage = (org.hyperledger.fabric.protos.common.MspPrincipal.MSPIdentityAnonymity) e.getUnfinishedMessage();
          throw e.unwrapIOException();
        } finally {
          if (parsedMessage != null) {
            mergeFrom(parsedMessage);
          }
        }
        return this;
      }

      private int anonymityType_ = 0;
      /**
       * <code>optional .common.MSPIdentityAnonymity.MSPIdentityAnonymityType anonymity_type = 1;</code>
       */
      public int getAnonymityTypeValue() {
        return anonymityType_;
      }
      /**
       * <code>optional .common.MSPIdentityAnonymity.MSPIdentityAnonymityType anonymity_type = 1;</code>
       */
      public Builder setAnonymityTypeValue(int value) {
        anonymityType_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional .common.MSPIdentityAnonymity.MSPIdentityAnonymityType anonymity_type = 1;</code>
       */
      public org.hyperledger.fabric.protos.common.MspPrincipal.MSPIdentityAnonymity.MSPIdentityAnonymityType getAnonymityType() {
        org.hyperledger.fabric.protos.common.MspPrincipal.MSPIdentityAnonymity.MSPIdentityAnonymityType result = org.hyperledger.fabric.protos.common.MspPrincipal.MSPIdentityAnonymity.MSPIdentityAnonymityType.valueOf(anonymityType_);
        return result == null ? org.hyperledger.fabric.protos.common.MspPrincipal.MSPIdentityAnonymity.MSPIdentityAnonymityType.UNRECOGNIZED : result;
      }
      /**
       * <code>optional .common.MSPIdentityAnonymity.MSPIdentityAnonymityType anonymity_type = 1;</code>
       */
      public Builder setAnonymityType(org.hyperledger.fabric.protos.common.MspPrincipal.MSPIdentityAnonymity.MSPIdentityAnonymityType value) {
        if (value == null) {
          throw new NullPointerException();
        }
        
        anonymityType_ = value.getNumber();
        onChanged();
        return this;
      }
      /**
       * <code>optional .common.MSPIdentityAnonymity.MSPIdentityAnonymityType anonymity_type = 1;</code>
       */
      public Builder clearAnonymityType() {
        
        anonymityType_ = 0;
        onChanged();
        return this;
      }
      public final Builder setUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return this;
      }

      public final Builder mergeUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return this;
      }


      // @@protoc_insertion_point(builder_scope:common.MSPIdentityAnonymity)
    }

    // @@protoc_insertion_point(class_scope:common.MSPIdentityAnonymity)
    private static final org.hyperledger.fabric.protos.common.MspPrincipal.MSPIdentityAnonymity DEFAULT_INSTANCE;
    static {
      DEFAULT_INSTANCE = new org.hyperledger.fabric.protos.common.MspPrincipal.MSPIdentityAnonymity();
    }

    public static org.hyperledger.fabric.protos.common.MspPrincipal.MSPIdentityAnonymity getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    private static final com.google.protobuf.Parser<MSPIdentityAnonymity>
        PARSER = new com.google.protobuf.AbstractParser<MSPIdentityAnonymity>() {
      public MSPIdentityAnonymity parsePartialFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
          return new MSPIdentityAnonymity(input, extensionRegistry);
      }
    };

    public static com.google.protobuf.Parser<MSPIdentityAnonymity> parser() {
      return PARSER;
    }

    @java.lang.Override
    public com.google.protobuf.Parser<MSPIdentityAnonymity> getParserForType() {
      return PARSER;
    }

    public org.hyperledger.fabric.protos.common.MspPrincipal.MSPIdentityAnonymity getDefaultInstanceForType() {
      return DEFAULT_INSTANCE;
    }

  }

  public interface CombinedPrincipalOrBuilder extends
      // @@protoc_insertion_point(interface_extends:common.CombinedPrincipal)
      com.google.protobuf.MessageOrBuilder {

    /**
     * <pre>
     * Principals refer to combined principals
     * </pre>
     *
     * <code>repeated .common.MSPPrincipal principals = 1;</code>
     */
    java.util.List<org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal> 
        getPrincipalsList();
    /**
     * <pre>
     * Principals refer to combined principals
     * </pre>
     *
     * <code>repeated .common.MSPPrincipal principals = 1;</code>
     */
    org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal getPrincipals(int index);
    /**
     * <pre>
     * Principals refer to combined principals
     * </pre>
     *
     * <code>repeated .common.MSPPrincipal principals = 1;</code>
     */
    int getPrincipalsCount();
    /**
     * <pre>
     * Principals refer to combined principals
     * </pre>
     *
     * <code>repeated .common.MSPPrincipal principals = 1;</code>
     */
    java.util.List<? extends org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipalOrBuilder> 
        getPrincipalsOrBuilderList();
    /**
     * <pre>
     * Principals refer to combined principals
     * </pre>
     *
     * <code>repeated .common.MSPPrincipal principals = 1;</code>
     */
    org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipalOrBuilder getPrincipalsOrBuilder(
        int index);
  }
  /**
   * <pre>
   * CombinedPrincipal governs the organization of the Principal
   * field of a policy principal when principal_classification has
   * indicated that a combined form of principals is required
   * </pre>
   *
   * Protobuf type {@code common.CombinedPrincipal}
   */
  public  static final class CombinedPrincipal extends
      com.google.protobuf.GeneratedMessageV3 implements
      // @@protoc_insertion_point(message_implements:common.CombinedPrincipal)
      CombinedPrincipalOrBuilder {
    // Use CombinedPrincipal.newBuilder() to construct.
    private CombinedPrincipal(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
      super(builder);
    }
    private CombinedPrincipal() {
      principals_ = java.util.Collections.emptyList();
    }

    @java.lang.Override
    public final com.google.protobuf.UnknownFieldSet
    getUnknownFields() {
      return com.google.protobuf.UnknownFieldSet.getDefaultInstance();
    }
    private CombinedPrincipal(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      this();
      int mutable_bitField0_ = 0;
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            default: {
              if (!input.skipField(tag)) {
                done = true;
              }
              break;
            }
            case 10: {
              if (!((mutable_bitField0_ & 0x00000001) == 0x00000001)) {
                principals_ = new java.util.ArrayList<org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal>();
                mutable_bitField0_ |= 0x00000001;
              }
              principals_.add(
                  input.readMessage(org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal.parser(), extensionRegistry));
              break;
            }
          }
        }
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(this);
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(
            e).setUnfinishedMessage(this);
      } finally {
        if (((mutable_bitField0_ & 0x00000001) == 0x00000001)) {
          principals_ = java.util.Collections.unmodifiableList(principals_);
        }
        makeExtensionsImmutable();
      }
    }
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return org.hyperledger.fabric.protos.common.MspPrincipal.internal_static_common_CombinedPrincipal_descriptor;
    }

    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return org.hyperledger.fabric.protos.common.MspPrincipal.internal_static_common_CombinedPrincipal_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              org.hyperledger.fabric.protos.common.MspPrincipal.CombinedPrincipal.class, org.hyperledger.fabric.protos.common.MspPrincipal.CombinedPrincipal.Builder.class);
    }

    public static final int PRINCIPALS_FIELD_NUMBER = 1;
    private java.util.List<org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal> principals_;
    /**
     * <pre>
     * Principals refer to combined principals
     * </pre>
     *
     * <code>repeated .common.MSPPrincipal principals = 1;</code>
     */
    public java.util.List<org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal> getPrincipalsList() {
      return principals_;
    }
    /**
     * <pre>
     * Principals refer to combined principals
     * </pre>
     *
     * <code>repeated .common.MSPPrincipal principals = 1;</code>
     */
    public java.util.List<? extends org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipalOrBuilder> 
        getPrincipalsOrBuilderList() {
      return principals_;
    }
    /**
     * <pre>
     * Principals refer to combined principals
     * </pre>
     *
     * <code>repeated .common.MSPPrincipal principals = 1;</code>
     */
    public int getPrincipalsCount() {
      return principals_.size();
    }
    /**
     * <pre>
     * Principals refer to combined principals
     * </pre>
     *
     * <code>repeated .common.MSPPrincipal principals = 1;</code>
     */
    public org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal getPrincipals(int index) {
      return principals_.get(index);
    }
    /**
     * <pre>
     * Principals refer to combined principals
     * </pre>
     *
     * <code>repeated .common.MSPPrincipal principals = 1;</code>
     */
    public org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipalOrBuilder getPrincipalsOrBuilder(
        int index) {
      return principals_.get(index);
    }

    private byte memoizedIsInitialized = -1;
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized == 1) return true;
      if (isInitialized == 0) return false;

      memoizedIsInitialized = 1;
      return true;
    }

    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      for (int i = 0; i < principals_.size(); i++) {
        output.writeMessage(1, principals_.get(i));
      }
    }

    public int getSerializedSize() {
      int size = memoizedSize;
      if (size != -1) return size;

      size = 0;
      for (int i = 0; i < principals_.size(); i++) {
        size += com.google.protobuf.CodedOutputStream
          .computeMessageSize(1, principals_.get(i));
      }
      memoizedSize = size;
      return size;
    }

    private static final long serialVersionUID = 0L;
    @java.lang.Override
    public boolean equals(final java.lang.Object obj) {
      if (obj == this) {
       return true;
      }
      if (!(obj instanceof org.hyperledger.fabric.protos.common.MspPrincipal.CombinedPrincipal)) {
        return super.equals(obj);
      }
      org.hyperledger.fabric.protos.common.MspPrincipal.CombinedPrincipal other = (org.hyperledger.fabric.protos.common.MspPrincipal.CombinedPrincipal) obj;

      boolean result = true;
      result = result && getPrincipalsList()
          .equals(other.getPrincipalsList());
      return result;
    }

    @java.lang.Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptorForType().hashCode();
      if (getPrincipalsCount() > 0) {
        hash = (37 * hash) + PRINCIPALS_FIELD_NUMBER;
        hash = (53 * hash) + getPrincipalsList().hashCode();
      }
      hash = (29 * hash) + unknownFields.hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static org.hyperledger.fabric.protos.common.MspPrincipal.CombinedPrincipal parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.hyperledger.fabric.protos.common.MspPrincipal.CombinedPrincipal parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.hyperledger.fabric.protos.common.MspPrincipal.CombinedPrincipal parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.hyperledger.fabric.protos.common.MspPrincipal.CombinedPrincipal parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.hyperledger.fabric.protos.common.MspPrincipal.CombinedPrincipal parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static org.hyperledger.fabric.protos.common.MspPrincipal.CombinedPrincipal parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }
    public static org.hyperledger.fabric.protos.common.MspPrincipal.CombinedPrincipal parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input);
    }
    public static org.hyperledger.fabric.protos.common.MspPrincipal.CombinedPrincipal parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
    }
    public static org.hyperledger.fabric.protos.common.MspPrincipal.CombinedPrincipal parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static org.hyperledger.fabric.protos.common.MspPrincipal.CombinedPrincipal parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }

    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder() {
      return DEFAULT_INSTANCE.toBuilder();
    }
    public static Builder newBuilder(org.hyperledger.fabric.protos.common.MspPrincipal.CombinedPrincipal prototype) {
      return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }
    public Builder toBuilder() {
      return this == DEFAULT_INSTANCE
          ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * <pre>
     * CombinedPrincipal governs the organization of the Principal
     * field of a policy principal when principal_classification has
     * indicated that a combined form of principals is required
     * </pre>
     *
     * Protobuf type {@code common.CombinedPrincipal}
     */
    public static final class Builder extends
        com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
        // @@protoc_insertion_point(builder_implements:common.CombinedPrincipal)
        org.hyperledger.fabric.protos.common.MspPrincipal.CombinedPrincipalOrBuilder {
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return org.hyperledger.fabric.protos.common.MspPrincipal.internal_static_common_CombinedPrincipal_descriptor;
      }

      protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return org.hyperledger.fabric.protos.common.MspPrincipal.internal_static_common_CombinedPrincipal_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                org.hyperledger.fabric.protos.common.MspPrincipal.CombinedPrincipal.class, org.hyperledger.fabric.protos.common.MspPrincipal.CombinedPrincipal.Builder.class);
      }

      // Construct using org.hyperledger.fabric.protos.common.MspPrincipal.CombinedPrincipal.newBuilder()
      private Builder() {
        maybeForceBuilderInitialization();
      }

      private Builder(
          com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
        super(parent);
        maybeForceBuilderInitialization();
      }
      private void maybeForceBuilderInitialization() {
        if (com.google.protobuf.GeneratedMessageV3
                .alwaysUseFieldBuilders) {
          getPrincipalsFieldBuilder();
        }
      }
      public Builder clear() {
        super.clear();
        if (principalsBuilder_ == null) {
          principals_ = java.util.Collections.emptyList();
          bitField0_ = (bitField0_ & ~0x00000001);
        } else {
          principalsBuilder_.clear();
        }
        return this;
      }

      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return org.hyperledger.fabric.protos.common.MspPrincipal.internal_static_common_CombinedPrincipal_descriptor;
      }

      public org.hyperledger.fabric.protos.common.MspPrincipal.CombinedPrincipal getDefaultInstanceForType() {
        return org.hyperledger.fabric.protos.common.MspPrincipal.CombinedPrincipal.getDefaultInstance();
      }

      public org.hyperledger.fabric.protos.common.MspPrincipal.CombinedPrincipal build() {
        org.hyperledger.fabric.protos.common.MspPrincipal.CombinedPrincipal result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      public org.hyperledger.fabric.protos.common.MspPrincipal.CombinedPrincipal buildPartial() {
        org.hyperledger.fabric.protos.common.MspPrincipal.CombinedPrincipal result = new org.hyperledger.fabric.protos.common.MspPrincipal.CombinedPrincipal(this);
        int from_bitField0_ = bitField0_;
        if (principalsBuilder_ == null) {
          if (((bitField0_ & 0x00000001) == 0x00000001)) {
            principals_ = java.util.Collections.unmodifiableList(principals_);
            bitField0_ = (bitField0_ & ~0x00000001);
          }
          result.principals_ = principals_;
        } else {
          result.principals_ = principalsBuilder_.build();
        }
        onBuilt();
        return result;
      }

      public Builder clone() {
        return (Builder) super.clone();
      }
      public Builder setField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          Object value) {
        return (Builder) super.setField(field, value);
      }
      public Builder clearField(
          com.google.protobuf.Descriptors.FieldDescriptor field) {
        return (Builder) super.clearField(field);
      }
      public Builder clearOneof(
          com.google.protobuf.Descriptors.OneofDescriptor oneof) {
        return (Builder) super.clearOneof(oneof);
      }
      public Builder setRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          int index, Object value) {
        return (Builder) super.setRepeatedField(field, index, value);
      }
      public Builder addRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          Object value) {
        return (Builder) super.addRepeatedField(field, value);
      }
      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof org.hyperledger.fabric.protos.common.MspPrincipal.CombinedPrincipal) {
          return mergeFrom((org.hyperledger.fabric.protos.common.MspPrincipal.CombinedPrincipal)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(org.hyperledger.fabric.protos.common.MspPrincipal.CombinedPrincipal other) {
        if (other == org.hyperledger.fabric.protos.common.MspPrincipal.CombinedPrincipal.getDefaultInstance()) return this;
        if (principalsBuilder_ == null) {
          if (!other.principals_.isEmpty()) {
            if (principals_.isEmpty()) {
              principals_ = other.principals_;
              bitField0_ = (bitField0_ & ~0x00000001);
            } else {
              ensurePrincipalsIsMutable();
              principals_.addAll(other.principals_);
            }
            onChanged();
          }
        } else {
          if (!other.principals_.isEmpty()) {
            if (principalsBuilder_.isEmpty()) {
              principalsBuilder_.dispose();
              principalsBuilder_ = null;
              principals_ = other.principals_;
              bitField0_ = (bitField0_ & ~0x00000001);
              principalsBuilder_ = 
                com.google.protobuf.GeneratedMessageV3.alwaysUseFieldBuilders ?
                   getPrincipalsFieldBuilder() : null;
            } else {
              principalsBuilder_.addAllMessages(other.principals_);
            }
          }
        }
        onChanged();
        return this;
      }

      public final boolean isInitialized() {
        return true;
      }

      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        org.hyperledger.fabric.protos.common.MspPrincipal.CombinedPrincipal parsedMessage = null;
        try {
          parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          parsedMessage = (org.hyperledger.fabric.protos.common.MspPrincipal.CombinedPrincipal) e.getUnfinishedMessage();
          throw e.unwrapIOException();
        } finally {
          if (parsedMessage != null) {
            mergeFrom(parsedMessage);
          }
        }
        return this;
      }
      private int bitField0_;

      private java.util.List<org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal> principals_ =
        java.util.Collections.emptyList();
      private void ensurePrincipalsIsMutable() {
        if (!((bitField0_ & 0x00000001) == 0x00000001)) {
          principals_ = new java.util.ArrayList<org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal>(principals_);
          bitField0_ |= 0x00000001;
         }
      }

      private com.google.protobuf.RepeatedFieldBuilderV3<
          org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal, org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal.Builder, org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipalOrBuilder> principalsBuilder_;

      /**
       * <pre>
       * Principals refer to combined principals
       * </pre>
       *
       * <code>repeated .common.MSPPrincipal principals = 1;</code>
       */
      public java.util.List<org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal> getPrincipalsList() {
        if (principalsBuilder_ == null) {
          return java.util.Collections.unmodifiableList(principals_);
        } else {
          return principalsBuilder_.getMessageList();
        }
      }
      /**
       * <pre>
       * Principals refer to combined principals
       * </pre>
       *
       * <code>repeated .common.MSPPrincipal principals = 1;</code>
       */
      public int getPrincipalsCount() {
        if (principalsBuilder_ == null) {
          return principals_.size();
        } else {
          return principalsBuilder_.getCount();
        }
      }
      /**
       * <pre>
       * Principals refer to combined principals
       * </pre>
       *
       * <code>repeated .common.MSPPrincipal principals = 1;</code>
       */
      public org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal getPrincipals(int index) {
        if (principalsBuilder_ == null) {
          return principals_.get(index);
        } else {
          return principalsBuilder_.getMessage(index);
        }
      }
      /**
       * <pre>
       * Principals refer to combined principals
       * </pre>
       *
       * <code>repeated .common.MSPPrincipal principals = 1;</code>
       */
      public Builder setPrincipals(
          int index, org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal value) {
        if (principalsBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensurePrincipalsIsMutable();
          principals_.set(index, value);
          onChanged();
        } else {
          principalsBuilder_.setMessage(index, value);
        }
        return this;
      }
      /**
       * <pre>
       * Principals refer to combined principals
       * </pre>
       *
       * <code>repeated .common.MSPPrincipal principals = 1;</code>
       */
      public Builder setPrincipals(
          int index, org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal.Builder builderForValue) {
        if (principalsBuilder_ == null) {
          ensurePrincipalsIsMutable();
          principals_.set(index, builderForValue.build());
          onChanged();
        } else {
          principalsBuilder_.setMessage(index, builderForValue.build());
        }
        return this;
      }
      /**
       * <pre>
       * Principals refer to combined principals
       * </pre>
       *
       * <code>repeated .common.MSPPrincipal principals = 1;</code>
       */
      public Builder addPrincipals(org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal value) {
        if (principalsBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensurePrincipalsIsMutable();
          principals_.add(value);
          onChanged();
        } else {
          principalsBuilder_.addMessage(value);
        }
        return this;
      }
      /**
       * <pre>
       * Principals refer to combined principals
       * </pre>
       *
       * <code>repeated .common.MSPPrincipal principals = 1;</code>
       */
      public Builder addPrincipals(
          int index, org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal value) {
        if (principalsBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensurePrincipalsIsMutable();
          principals_.add(index, value);
          onChanged();
        } else {
          principalsBuilder_.addMessage(index, value);
        }
        return this;
      }
      /**
       * <pre>
       * Principals refer to combined principals
       * </pre>
       *
       * <code>repeated .common.MSPPrincipal principals = 1;</code>
       */
      public Builder addPrincipals(
          org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal.Builder builderForValue) {
        if (principalsBuilder_ == null) {
          ensurePrincipalsIsMutable();
          principals_.add(builderForValue.build());
          onChanged();
        } else {
          principalsBuilder_.addMessage(builderForValue.build());
        }
        return this;
      }
      /**
       * <pre>
       * Principals refer to combined principals
       * </pre>
       *
       * <code>repeated .common.MSPPrincipal principals = 1;</code>
       */
      public Builder addPrincipals(
          int index, org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal.Builder builderForValue) {
        if (principalsBuilder_ == null) {
          ensurePrincipalsIsMutable();
          principals_.add(index, builderForValue.build());
          onChanged();
        } else {
          principalsBuilder_.addMessage(index, builderForValue.build());
        }
        return this;
      }
      /**
       * <pre>
       * Principals refer to combined principals
       * </pre>
       *
       * <code>repeated .common.MSPPrincipal principals = 1;</code>
       */
      public Builder addAllPrincipals(
          java.lang.Iterable<? extends org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal> values) {
        if (principalsBuilder_ == null) {
          ensurePrincipalsIsMutable();
          com.google.protobuf.AbstractMessageLite.Builder.addAll(
              values, principals_);
          onChanged();
        } else {
          principalsBuilder_.addAllMessages(values);
        }
        return this;
      }
      /**
       * <pre>
       * Principals refer to combined principals
       * </pre>
       *
       * <code>repeated .common.MSPPrincipal principals = 1;</code>
       */
      public Builder clearPrincipals() {
        if (principalsBuilder_ == null) {
          principals_ = java.util.Collections.emptyList();
          bitField0_ = (bitField0_ & ~0x00000001);
          onChanged();
        } else {
          principalsBuilder_.clear();
        }
        return this;
      }
      /**
       * <pre>
       * Principals refer to combined principals
       * </pre>
       *
       * <code>repeated .common.MSPPrincipal principals = 1;</code>
       */
      public Builder removePrincipals(int index) {
        if (principalsBuilder_ == null) {
          ensurePrincipalsIsMutable();
          principals_.remove(index);
          onChanged();
        } else {
          principalsBuilder_.remove(index);
        }
        return this;
      }
      /**
       * <pre>
       * Principals refer to combined principals
       * </pre>
       *
       * <code>repeated .common.MSPPrincipal principals = 1;</code>
       */
      public org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal.Builder getPrincipalsBuilder(
          int index) {
        return getPrincipalsFieldBuilder().getBuilder(index);
      }
      /**
       * <pre>
       * Principals refer to combined principals
       * </pre>
       *
       * <code>repeated .common.MSPPrincipal principals = 1;</code>
       */
      public org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipalOrBuilder getPrincipalsOrBuilder(
          int index) {
        if (principalsBuilder_ == null) {
          return principals_.get(index);  } else {
          return principalsBuilder_.getMessageOrBuilder(index);
        }
      }
      /**
       * <pre>
       * Principals refer to combined principals
       * </pre>
       *
       * <code>repeated .common.MSPPrincipal principals = 1;</code>
       */
      public java.util.List<? extends org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipalOrBuilder> 
           getPrincipalsOrBuilderList() {
        if (principalsBuilder_ != null) {
          return principalsBuilder_.getMessageOrBuilderList();
        } else {
          return java.util.Collections.unmodifiableList(principals_);
        }
      }
      /**
       * <pre>
       * Principals refer to combined principals
       * </pre>
       *
       * <code>repeated .common.MSPPrincipal principals = 1;</code>
       */
      public org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal.Builder addPrincipalsBuilder() {
        return getPrincipalsFieldBuilder().addBuilder(
            org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal.getDefaultInstance());
      }
      /**
       * <pre>
       * Principals refer to combined principals
       * </pre>
       *
       * <code>repeated .common.MSPPrincipal principals = 1;</code>
       */
      public org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal.Builder addPrincipalsBuilder(
          int index) {
        return getPrincipalsFieldBuilder().addBuilder(
            index, org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal.getDefaultInstance());
      }
      /**
       * <pre>
       * Principals refer to combined principals
       * </pre>
       *
       * <code>repeated .common.MSPPrincipal principals = 1;</code>
       */
      public java.util.List<org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal.Builder> 
           getPrincipalsBuilderList() {
        return getPrincipalsFieldBuilder().getBuilderList();
      }
      private com.google.protobuf.RepeatedFieldBuilderV3<
          org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal, org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal.Builder, org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipalOrBuilder> 
          getPrincipalsFieldBuilder() {
        if (principalsBuilder_ == null) {
          principalsBuilder_ = new com.google.protobuf.RepeatedFieldBuilderV3<
              org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal, org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipal.Builder, org.hyperledger.fabric.protos.common.MspPrincipal.MSPPrincipalOrBuilder>(
                  principals_,
                  ((bitField0_ & 0x00000001) == 0x00000001),
                  getParentForChildren(),
                  isClean());
          principals_ = null;
        }
        return principalsBuilder_;
      }
      public final Builder setUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return this;
      }

      public final Builder mergeUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return this;
      }


      // @@protoc_insertion_point(builder_scope:common.CombinedPrincipal)
    }

    // @@protoc_insertion_point(class_scope:common.CombinedPrincipal)
    private static final org.hyperledger.fabric.protos.common.MspPrincipal.CombinedPrincipal DEFAULT_INSTANCE;
    static {
      DEFAULT_INSTANCE = new org.hyperledger.fabric.protos.common.MspPrincipal.CombinedPrincipal();
    }

    public static org.hyperledger.fabric.protos.common.MspPrincipal.CombinedPrincipal getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    private static final com.google.protobuf.Parser<CombinedPrincipal>
        PARSER = new com.google.protobuf.AbstractParser<CombinedPrincipal>() {
      public CombinedPrincipal parsePartialFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
          return new CombinedPrincipal(input, extensionRegistry);
      }
    };

    public static com.google.protobuf.Parser<CombinedPrincipal> parser() {
      return PARSER;
    }

    @java.lang.Override
    public com.google.protobuf.Parser<CombinedPrincipal> getParserForType() {
      return PARSER;
    }

    public org.hyperledger.fabric.protos.common.MspPrincipal.CombinedPrincipal getDefaultInstanceForType() {
      return DEFAULT_INSTANCE;
    }

  }

  private static final com.google.protobuf.Descriptors.Descriptor
    internal_static_common_MSPPrincipal_descriptor;
  private static final 
    com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internal_static_common_MSPPrincipal_fieldAccessorTable;
  private static final com.google.protobuf.Descriptors.Descriptor
    internal_static_common_OrganizationUnit_descriptor;
  private static final 
    com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internal_static_common_OrganizationUnit_fieldAccessorTable;
  private static final com.google.protobuf.Descriptors.Descriptor
    internal_static_common_MSPRole_descriptor;
  private static final 
    com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internal_static_common_MSPRole_fieldAccessorTable;
  private static final com.google.protobuf.Descriptors.Descriptor
    internal_static_common_MSPIdentityAnonymity_descriptor;
  private static final 
    com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internal_static_common_MSPIdentityAnonymity_fieldAccessorTable;
  private static final com.google.protobuf.Descriptors.Descriptor
    internal_static_common_CombinedPrincipal_descriptor;
  private static final 
    com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internal_static_common_CombinedPrincipal_fieldAccessorTable;

  public static com.google.protobuf.Descriptors.FileDescriptor
      getDescriptor() {
    return descriptor;
  }
  private static  com.google.protobuf.Descriptors.FileDescriptor
      descriptor;
  static {
    java.lang.String[] descriptorData = {
      "\n\027msp/msp_principal.proto\022\006common\"\306\001\n\014MS" +
      "PPrincipal\022E\n\030principal_classification\030\001" +
      " \001(\0162#.common.MSPPrincipal.Classificatio" +
      "n\022\021\n\tprincipal\030\002 \001(\014\"\\\n\016Classification\022\010" +
      "\n\004ROLE\020\000\022\025\n\021ORGANIZATION_UNIT\020\001\022\014\n\010IDENT" +
      "ITY\020\002\022\r\n\tANONYMITY\020\003\022\014\n\010COMBINED\020\004\"q\n\020Or" +
      "ganizationUnit\022\026\n\016msp_identifier\030\001 \001(\t\022&" +
      "\n\036organizational_unit_identifier\030\002 \001(\t\022\035" +
      "\n\025certifiers_identifier\030\003 \001(\014\"\210\001\n\007MSPRol" +
      "e\022\026\n\016msp_identifier\030\001 \001(\t\022)\n\004role\030\002 \001(\0162",
      "\033.common.MSPRole.MSPRoleType\":\n\013MSPRoleT" +
      "ype\022\n\n\006MEMBER\020\000\022\t\n\005ADMIN\020\001\022\n\n\006CLIENT\020\002\022\010" +
      "\n\004PEER\020\003\"\235\001\n\024MSPIdentityAnonymity\022M\n\016ano" +
      "nymity_type\030\001 \001(\01625.common.MSPIdentityAn" +
      "onymity.MSPIdentityAnonymityType\"6\n\030MSPI" +
      "dentityAnonymityType\022\013\n\007NOMINAL\020\000\022\r\n\tANO" +
      "NYMOUS\020\001\"=\n\021CombinedPrincipal\022(\n\nprincip" +
      "als\030\001 \003(\0132\024.common.MSPPrincipalBP\n$org.h" +
      "yperledger.fabric.protos.commonZ(github." +
      "com/hyperledger/fabric/protos/mspb\006proto",
      "3"
    };
    com.google.protobuf.Descriptors.FileDescriptor.InternalDescriptorAssigner assigner =
        new com.google.protobuf.Descriptors.FileDescriptor.    InternalDescriptorAssigner() {
          public com.google.protobuf.ExtensionRegistry assignDescriptors(
              com.google.protobuf.Descriptors.FileDescriptor root) {
            descriptor = root;
            return null;
          }
        };
    com.google.protobuf.Descriptors.FileDescriptor
      .internalBuildGeneratedFileFrom(descriptorData,
        new com.google.protobuf.Descriptors.FileDescriptor[] {
        }, assigner);
    internal_static_common_MSPPrincipal_descriptor =
      getDescriptor().getMessageTypes().get(0);
    internal_static_common_MSPPrincipal_fieldAccessorTable = new
      com.google.protobuf.GeneratedMessageV3.FieldAccessorTable(
        internal_static_common_MSPPrincipal_descriptor,
        new java.lang.String[] { "PrincipalClassification", "Principal", });
    internal_static_common_OrganizationUnit_descriptor =
      getDescriptor().getMessageTypes().get(1);
    internal_static_common_OrganizationUnit_fieldAccessorTable = new
      com.google.protobuf.GeneratedMessageV3.FieldAccessorTable(
        internal_static_common_OrganizationUnit_descriptor,
        new java.lang.String[] { "MspIdentifier", "OrganizationalUnitIdentifier", "CertifiersIdentifier", });
    internal_static_common_MSPRole_descriptor =
      getDescriptor().getMessageTypes().get(2);
    internal_static_common_MSPRole_fieldAccessorTable = new
      com.google.protobuf.GeneratedMessageV3.FieldAccessorTable(
        internal_static_common_MSPRole_descriptor,
        new java.lang.String[] { "MspIdentifier", "Role", });
    internal_static_common_MSPIdentityAnonymity_descriptor =
      getDescriptor().getMessageTypes().get(3);
    internal_static_common_MSPIdentityAnonymity_fieldAccessorTable = new
      com.google.protobuf.GeneratedMessageV3.FieldAccessorTable(
        internal_static_common_MSPIdentityAnonymity_descriptor,
        new java.lang.String[] { "AnonymityType", });
    internal_static_common_CombinedPrincipal_descriptor =
      getDescriptor().getMessageTypes().get(4);
    internal_static_common_CombinedPrincipal_fieldAccessorTable = new
      com.google.protobuf.GeneratedMessageV3.FieldAccessorTable(
        internal_static_common_CombinedPrincipal_descriptor,
        new java.lang.String[] { "Principals", });
  }

  // @@protoc_insertion_point(outer_class_scope)
}
